/*
 * @(#)article.c	1.34 Feb.1,1996
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * Copyright (C) yamasita@omronsoft.co.jp
 */

#if defined(WINDOWS)
#	include	<windows.h>
#	include	"wingn.h"
#endif	/* WINDOWS */

#include <stdio.h>
#include <ctype.h>

#ifdef	MSDOS
#	include	<stdlib.h>
#	include	<string.h>
#	include	<io.h>
#	if defined(WATTCP)
#		include <tcp.h>
#	endif
#	ifdef PCNFS
#		include "pcnfs.h"
#	endif
#	ifdef	QUICKWIN
#		include	<io.h>
#	endif
#endif /* MSDOS */

#ifdef	UNIX
#	ifdef	HAS_STRING_H
#		include	<string.h>
#	endif
#	ifdef	HAS_STDLIB_H
#		include	<stdlib.h>
#	endif
#	ifdef	HAS_MALLOC_H
#		include	<malloc.h>
#	endif
#	ifdef	HAS_UNISTD_H
#		include	<unistd.h>
#	endif
#endif /* UNIX */

#include	"nntp.h"
#include	"gn.h"

extern char *kb_input();
extern void reply_mode();
extern void mail_mode();
extern void save_mode();
extern void pipe_mode();
extern char *expand_filename();
extern char *article_filename();
extern int get_1_header_file();
extern void mc_puts(),mc_printf();
extern void hit_return();
extern void kanji_convert();
extern int kb_search();
extern int put_server();
extern int sregcmp();
extern int get_server();
extern int get_1_header();
extern newsgroup_t *search_group();
extern void set_unreaded();
extern void str_cut();
extern void gn_help();
extern char *Fgets();

#if defined(WINDOWS)
extern int mc_MessageBox();
extern int setmenu();
extern void fast_mc_puts_start(),fast_mc_puts_end();
extern void set_hourglass(),reset_cursor();
#endif	/* WINDOWS */

#ifdef	MIME
extern void MIME_strHeaderDecode();
#endif


static newsgroup_t *ng;	/* ȥ˥塼롼ץꥹ */
static subject_t *sb;	/* ȥ֥ȥꥹ */
static int top;			/* ꥹȤǽιֹ */
static long start;		/* ꥹȤ줿ǽ̤ɵֹ */
static int autolist_sv;

static char article_not_found[] = "\nε¸ߤޤ \n\007";
static char sea_artname[80] = "";

static void article_unread(),article_search(), article_search_rev(),
	xref_mark(),search_child();
static search_ref(),gmt_to_jst();

/* ƥ⡼ */
#ifndef	WINDOWS
int
article_mode(group,subject)
newsgroup_t *group;				/* ȥ˥塼롼ץꥹ */
register subject_t *subject;	/* ȥ֥ȥꥹ */
{
  void article_make_thread();
  void article_make_order();
  void article_mode_list();
  int article_mode_command();
  
  char key_buf[KEY_BUF_LEN];
  register char *pt;
  autolist_sv = gn.autolist;
  gn.autolist = 1;
  
  ng = group;
  sb = subject;
  top = 0;
  
  if ( disp_mode == THREADED && (sb->flag & THREADED) == 0 ){
    article_make_thread(sb);
    sb->flag |= THREADED;
  } else if (disp_mode != THREADED && (sb->flag & THREADED) != 0 ){
    article_make_order(sb);
    sb->flag &= ~THREADED;
  }
  
  while(1) {
    /* ɽ */
    article_mode_list();
    gn.autolist = autolist_sv;

    /* ޥ */
    memset(key_buf,0,KEY_BUF_LEN);
    redraw_func = article_mode_list;
    while ( FGETS(key_buf,KEY_BUF_LEN,stdin) == NULL ) {
      clearerr(stdin);
      article_mode_list();
    }
    redraw_func = (void (*)())NULL;
    pt = &key_buf[strlen(key_buf)-1];
    while( pt >= key_buf && ( *pt == ' ' || *pt == '\t' || *pt == '\n' ) )
      *pt-- = 0;

    /* Ԥۥ磻ȥڡ򥹥å */
    pt = key_buf;
    while(*pt == ' ' || *pt == '\t' )
      pt++;


    /* ޥɲ */
    switch ( article_mode_command(pt) ) {
    case END:			/* a ޥɤǡɤ / unsub */
      return(END);
    case QUIT:			/* ̤ɤεʤ */
      return(CONT);
    case NEXT:			/* Υ֥ */
      break;
    case SELECT:
      return(SELECT);
    case CONNECTION_CLOSED:
      return(CONNECTION_CLOSED);
    }
  }
}
#else	/* WINDOWS */
article_mode(group,subject)
newsgroup_t *group;				/* ȥ˥塼롼ץꥹ */
register subject_t *subject;	/* ȥ֥ȥꥹ */
{
  extern void article_make_thread();
  extern void article_make_order();

  int autolist_sv;

  autolist_sv = gn.autolist;
  gn.autolist = 1;

  ng = group;
  sb = subject;
  top = 0;

  if ( disp_mode == THREADED && (sb->flag & THREADED) == 0 ){
    article_make_thread(sb);
    sb->flag |= THREADED;
  } else if (disp_mode != THREADED && (sb->flag & THREADED) != 0 ){
    article_make_order(sb);
    sb->flag &= ~THREADED;
  }

  return(CONT);
}
set_articlemode_menu()
{
  static gnpopupmenu_t articlemode_file_menu[] = {
#ifndef	NO_SAVE
    { "Ǹɤե¸(\036S)",
	IDM_SAVE,		AFTER_READ|SEPARATOR_NEXT },
#endif /* NO_SAVE */
    { "Υ֥Ȥ(\036P)",
	IDM_ARTPREVSUB,		0 },
    { "Υ֥Ȥ(\036N)",
	IDM_ARTNEXTSUB,		0 },
    { "֥ȥ⡼ɤ(\036Q)",
	IDM_ARTQUIT,			0 },
    { 0,0,0 }
  };
  
  static gnpopupmenu_t articlemode_edit_menu[] = {
    { "ֹ桢åɣĤλ...",
	IDM_ARTCOMMAND,		SEPARATOR_NEXT },

    { "ƼԤθ(\036/)...",
	IDM_ARTSEARCH,		0 },
    { "ƼԤεո(\036\\)...",
	IDM_ARTREVSEARCH,		SEPARATOR_NEXT },

    { "Υ롼פϤ⤦ɤޤʤ(\036U)",
	IDM_ARTUNSUBSCRIBE,	0 },
    { "Υ롼פϤäѤɤ(\036S)",
	IDM_ARTSUBSCRIBE,		SEPARATOR_NEXT },

    { "̤ɤεɤȤˤ(\036C)",
	IDM_ARTCATCHUP,		0 },
    { "ꤷֹε̤ɤˤ...",
	IDM_ARTUNREAD,		0 },
    { 0,0,0 }
  };
  
  static gnpopupmenu_t articlemode_view_menu[] = {
    { "̤ɽ(\036P)",
	IDM_ARTPREV,			0 },
    { "̤ɽ(\036N)",
	IDM_ARTNEXT,			0 },
    { "",			/* programable */
	IDM_ARTTRUNC,			SEPARATOR_NEXT },

    { "",			/* programable */
	IDM_ARTLIST,			SEPARATOR_NEXT },

    { "Ǹɤθɽ(\036R)",
	IDM_REFERENCE,		AFTER_READ|SEPARATOR_NEXT },

    { "̤ɤ򤹤(\036A)",
	IDM_ARTALL,			0 },
    { 0,0,0 }
  };
  
  
  static gnpopupmenu_t articlemode_send_menu[] = {
    { "Ǹɤ˥եФ(\036F)",
	IDM_FOLLOW,			AFTER_READ },
    { "Ǹɤ˥ץ饤ᥤФ(\036R)",
	IDM_REPLY,			AFTER_READ },
    { "Ǹɤ򥭥󥻥뤹(\036C)",
	IDM_CANCEL,			AFTER_READ|SEPARATOR_NEXT },

    { "ݥȤ(\036I)...",
	IDM_POST,				0 },
    { "ᥤ(\036M)...",
	IDM_MAIL,				0 },
    { 0,0,0 }

  };
  
  static gnpopupmenu_t articlemode_help_menu[] = {
    { "ޥɰɽ(\036?)...",
	IDM_ARTHELP, 			0 },
    { "С(\036A)...",
	IDM_ABOUT, 			0 },
    { 0,0,0 }
  };
  
  static gnmenu_t articlemode_menu[] = {
    { "ե(\036F)",	articlemode_file_menu },
    { "Խ(\036E)",		articlemode_edit_menu },
    { "ɽ(\036V)",		articlemode_view_menu },
    { "ȯ(\036S)",		articlemode_send_menu },
    { "إ(\036H)",		articlemode_help_menu },
    { 0,0 }
  };
  
  static char
    *disp_trunc    = "ĹԤޤʤɽ(\036T)",
    *disp_nottrunc = "ĹԤޤʤɽʤ(\036T)";
  
  static char
    *disp_thread   = "Ƚɽ(\036L)",
    *disp_notthread= "Ƚɽʤ(\036L)";
  
  gnpopupmenu_t *gnpm;
  
  for ( gnpm = articlemode_view_menu ; gnpm->item != 0 ; gnpm++ ) {
    if ( gnpm->idm == IDM_ARTTRUNC ) {
      if ( gn.show_truncate == ON )
	gnpm->item = disp_nottrunc;
      else
	gnpm->item = disp_trunc;
      continue;
    }
    if ( gnpm->idm == IDM_ARTLIST ) {
      if ( (disp_mode & THREADED) == 0 )
	gnpm->item = disp_thread;
      else
	gnpm->item = disp_notthread;
      continue;
    }
  }
  return(setmenu(articlemode_menu));
}
articlemode_menu_exec(wParam)
WPARAM wParam;
{
  void win_article_mode_command();
  void article_mode_list();
  
  register char *pt;
  char key_buf[2];
  
  pt = key_buf;
  key_buf[1] = 0;
  
  switch ( wParam ) {
  case IDM_ARTCOMMAND:
    if ((pt = kb_input("ֹϤƲ")) == NULL )
      return(NULL);
    break;
  case IDM_ARTPREV:
    *pt = 'p';
    break;
  case IDM_ARTNEXT:
    *pt = 'n';
    break;
  case IDM_ARTTRUNC:
    *pt = 't';
    break;
  case IDM_ARTALL:
    *pt = 'a';
    break;
  case IDM_ARTUNSUBSCRIBE:
    *pt = 'u';
    break;
  case IDM_ARTSUBSCRIBE:
    *pt = 'S';
    break;
  case IDM_ARTCATCHUP:
    *pt = 'c';
    break;
  case IDM_ARTUNREAD:
    *pt = 'U';
    break;
  case IDM_ARTLIST:
    *pt = 'l';
    break;
  case IDM_ARTSEARCH:
    *pt = '/';
    break;
  case IDM_ARTREVSEARCH:
    *pt = '\\';
    break;
  case IDM_ARTPREVSUB:
    *pt = 'P';
    break;
  case IDM_ARTNEXTSUB:
    *pt = 'N';
    break;
  case IDM_ARTQUIT:
    *pt = 'q';
    break;
  case IDM_ARTHELP:
    *pt = '?';
    break;
  default:
    return(NULL);
  }
  
  win_article_mode_command(pt);
  
  if ( wParam == IDM_ARTTRUNC || wParam == IDM_ARTLIST)
    set_articlemode_menu();
  
  return(NULL);
}
void
win_article_mode_command(pt)
char *pt;
{
  int article_mode_command();
  
  switch ( article_mode_command(pt) ) {
  case CONT:
    article_mode_list();
    return;
  case END:			/* a ޥɤǡɤ / unsub */
    PostMessage(hWnd, WM_GROUPMODE,0 , 0L);
    return;
  case QUIT:
    PostMessage(hWnd, WM_SUBJECTMODE,0 , 0L);
    return;
  case NEXT:			/* Υ֥ */
    PostMessage(hWnd, WM_ARTICLEMODE,0 , 0L);
    return;
  case CONNECTION_CLOSED:
    return;
  case SELECT:
    return;
  }
  return;
}
#endif	/* WINDOWS */
/*
 * ƥ⡼ɰɽ
 */
void
article_mode_list()
{
  register int i,count;
  register article_t *ar;
  register char *pt;
  char buf[NNTP_STRLEN*2+1];
#ifdef	WINDOWS
  char buf2[NNTP_STRLEN*2+1];
#endif	/* WINDOWS */
  int	sb_width;
  
  start = -1;
#ifndef WINDOWS
  mc_puts("\n");
#else	/* WINDOWS */
  fast_mc_puts_start();
#endif	/* WINDOWS */
  
  if ( gn.autolist != 0 ) {
#ifndef	WINDOWS
    sb_width = gn.columns;
#ifndef	QUICKWIN
    if ( gn.cls == ON )
      mc_puts(CLS_STRING);
#endif

    if ( gn.show_indent > 0 ) {
      mc_printf("%*c", gn.show_indent * 2, ' ');
      sb_width -= gn.show_indent * 2;
    }
    sprintf(buf,"ƥ⡼ɡ%s",ng->name);
    if ( sb->flag & NOTREONLY ) {
      strcat(buf,":");
    } else {
      strcat(buf,":Re: ");
    }
    strcat(buf,sb->name);
    strcat(buf,"");
    if ( gn.show_truncate == OFF ) {
      if ( (int)strlen(buf) > sb_width)
	str_cut(buf,sb_width);
    }
    mc_printf("%s\n\n",buf);
#else  /* WINDOWS */
    sprintf(buf,"ƥ⡼ %s %s%s",
	    ng->name,
	    ((sb->flag & NOTREONLY ) != 0) ? "" : "Re: ",
	    sb->name);
    kanji_convert(internal_kanji_code,buf,gn.display_kanji_code,buf2);
    SetWindowText(hWnd,buf2);
#endif /* WINDOWS */

    if ( gn.show_indent > 0 )
      mc_printf("%*c", gn.show_indent * 2, ' ');
    mc_puts("  ֹ  Կ Ƽ\n");

    while(1){
      for ( i = 0 ,ar = sb->art; i < top && ar != 0 ; i++,ar=ar->next)
	;
      count = 0;
      start = -1;
      for (  ; ar != 0 ; ar = ar->next) {
	sb_width = gn.columns;
	if ( gn.show_indent > 0 ) {
	  mc_printf("%*c", gn.show_indent * 2, ' ');
	  sb_width -= gn.show_indent * 2;
	}
					
	if ( ar->flag ) {	/*  */
	  mc_puts("R");
	} else {		/* ̤ */
	  if ( start == -1 )
	    start = ar->numb;	/* ̤ɤκǽεֹ */
	  mc_puts(" ");
	}
	sb_width--;

	if (ar->lines > -1)
	  mc_printf("%5ld %5d ",ar->numb,ar->lines);
	else
	  mc_printf("%5ld       ",ar->numb);

	sb_width -= 5 + 1 + 5 + 1;
					
	if ( gn.show_truncate == ON ) {
	  mc_puts(ar->from);
	  mc_printf("\n");
	} else {
	  strcpy(buf,ar->from);
	  if ( (pt = strchr(buf,'\n')) != NULL )
	    *pt = 0;
	  str_cut(buf,sb_width);
	  mc_printf("%s\n",buf);
	}
	if ( ++count >= EFFECT_LINES )
	  break;
      }
      if ( count == 0 ){
	top -= EFFECT_LINES;
	if ( top < 0 )
	  top = 0;
	continue;
      }
      break;
    }
  }
  if ( gn.show_indent > 0 )
    mc_printf("%*c", gn.show_indent * 2, ' ');
  mc_puts("ֹޤϥޥɡhelp=?ˡ");
#ifndef	WINDOWS
  fflush(stdout);
#else	/* WINDOWS */
  fast_mc_puts_end();
  
  count = 0;
  for ( ar = sb->art; ar != 0 ; ar=ar->next)
    count++;
  
  SetScrollRange(hWnd,SB_VERT,0,count,FALSE);
  SetScrollPos(hWnd,SB_VERT,top,TRUE);
#endif	/* WINDOWS */
}

/*
 * ƥ⡼ɥޥ
 */
int
article_mode_command(pt)
register char *pt;
{
  extern int show_article();
  extern int post_mode();
  extern int reference_mode();
  extern int followup_mode();
  extern int cancel_mode();
  extern void shell_mode();
  extern int show_article_id();
  extern void article_make_thread();
  extern void article_make_order();
  extern int article_all_article();
  extern void article_mode_help();
  
  register article_t *ar;
  register int arg;
  long argl;
  subject_t *nsb,*psb;
  
  /* ֹ */
  if ( '0' <= *pt && *pt <= '9' ) {
    argl = atol(pt);
    switch ( show_article(argl) ){
    case CONNECTION_CLOSED:
      return(CONNECTION_CLOSED);
    case CONT:
      for ( ar = sb->art; ar != 0 ; ar=ar->next) {
	if ( ar->numb == argl ) {
	  if ( ar->flag == 0 ) {
	    ar->flag = 1;
	    sb->numb--;
	  }
	  break;
	}
      }
      break;
    case FILE_WRITE_ERROR:
      mc_puts("ƥݥեκ˼Ԥޤ\n");
      break;
    case SELECT:		/* WINDOWS */
      for ( ar = sb->art; ar != 0 ; ar=ar->next) {
	if ( ar->numb == argl ) {
	  if ( ar->flag == 0 ) {
	    ar->flag = 1;
	    sb->numb--;
	  }
	  break;
	}
      }
      return(SELECT);
    }
    return(CONT);
  }
  
  /* CRΤߡǽ̤ɵ */
  if ( *pt == 0 ){
    if ( start == -1 ) {	/* ̤ɤεꥹȤƤʤ */
      for ( ar = sb->art, top = 0; ar != 0 ; ar=ar->next,top++) {
	if ( ar->flag == 0 ) {
	  start = ar->numb;
	  break;
	}
      }
      if ( start == -1 ){
#ifndef	WINDOWS
	mc_puts("\n̤ɤεϤޤ \n");
#endif /* WINDOWS */
	return(QUIT);
      }
    }
    switch ( show_article(start) ){
    case CONNECTION_CLOSED:
      return(CONNECTION_CLOSED);
    case CONT:
      for ( ar = sb->art; ar != 0 ; ar=ar->next) {
	if ( ar->numb == start ) {
	  if ( ar->flag == 0 ) {
	    ar->flag = 1;
	    sb->numb--;
	  }
	  break;
	}
      }
      break;
    case FILE_WRITE_ERROR:
      mc_puts("ƥݥեκ˼Ԥޤ\n");
      break;
    case ARTICLE_NOT_FOUND:
      /* ƥ륭塼˥å夷Ƥ
	 󥻥뤵줿硢-1 ֤ä롣
	 ƥ륭塼
	 󥻥륭塼ˤĤʤľʤФʤʤ
	 */
      break;
    case SELECT:		/* WINDOWS */
      for ( ar = sb->art; ar != 0 ; ar=ar->next) {
	if ( ar->numb == start ) {
	  if ( ar->flag == 0 ) {
	    ar->flag = 1;
	    sb->numb--;
	  }
	  break;
	}
      }
      return(SELECT);
    }
    return(CONT);
  }
  
  /* ʸΥޥ */
  if ( pt[1] == 0 ) {
    switch ( *pt ) {
    case 'a':			/*  */
#ifndef	WINDOWS
      if ( article_all_article() == CONNECTION_CLOSED )
	return(CONNECTION_CLOSED);
      return(QUIT);
#else  /* WINDOWS */
      PostMessage(hWnd, WM_ARTICLEALL,0 , 0L);
      return(SELECT);
#endif /* WINDOWS */
    case 'd':
      gn.autolist = 1;
      return(CONT);
			
    case 't':
      gn.autolist = 1;
      gn.show_truncate ^= ON;
      return(CONT);
			
    case 'P':			/* Υ֥ */
      gn.autolist = 1;
			
      if ( sb == ng->subj ) {
	gn.autolist = autolist_sv;
	mc_puts("\nΥ֥Ȥ¸ߤޤ \n");
	return(QUIT);
      }
      for ( nsb = ng->subj ; nsb != sb ; nsb = nsb->next)
	psb = nsb;
			
      mc_printf("\nΥ֥Ȥ %s Ǥ\n",psb->name);
      sb = psb;
      if ( disp_mode == THREADED && (sb->flag & THREADED) == 0 ){
	article_make_thread(sb);
	sb->flag |= THREADED;
      } else if (disp_mode != THREADED && (sb->flag & THREADED) != 0 ){
	article_make_order(sb);
	sb->flag &= ~THREADED;
      }
      top = 0;
      return(NEXT);
			
    case 'N':			/* Υ֥ */
      gn.autolist = 1;
			
      if ( sb->next == 0 ) {
	gn.autolist = autolist_sv;
	mc_puts("\nΥ֥Ȥ¸ߤޤ \n");
	return(QUIT);
      }
      mc_printf("\nΥ֥Ȥ %s Ǥ\n",sb->next->name);
      sb = sb->next;
      if ( disp_mode == THREADED && (sb->flag & THREADED) == 0 ){
	article_make_thread(sb);
	sb->flag |= THREADED;
      } else if (disp_mode != THREADED && (sb->flag & THREADED) != 0 ){
	article_make_order(sb);
	sb->flag &= ~THREADED;
      }
      top = 0;
      return(NEXT);
			
    case 'i':			/* ݥ */
      return(post_mode(ng->name));
    case 'R':			/* reference */
      return(reference_mode());
    case 'f':			/* ե */
      return(followup_mode());
    case 'r':			/* ץ饤 */
      reply_mode();
      return(CONT);
    case 'm':			/* ᥤ */
      mail_mode();
      return(CONT);
    case 'C':			/* 󥻥 */
      return(cancel_mode());
    case 'u':			/* ⤦ɤޤʤ */
#ifndef	WINDOWS
      pt = kb_input("⤦ꥹȥåפޤ(y:λ/¾:)");
      if ( *pt == 'y' || *pt == 'Y' ){
	ng->flag |= UNSUBSCRIBE;
	change = 1;
	return(END);
      }
#else  /* WINDOWS */
      if ( mc_MessageBox(hWnd,"⤦ꥹȥåפޤ ",
			 "",MB_OKCANCEL) == IDOK ){
	ng->flag |= UNSUBSCRIBE;
	change = 1;
	return(END);
      }
#endif /* WINDOWS */
      return(CONT);
    case 'S':			/* äѤɤ */
      if ( ng->flag & UNSUBSCRIBE ) {
	ng->flag &= ~UNSUBSCRIBE;
	change = 1;
      }
      return(CONT);
    case 'c':			/* ɤȤˤ */
      for ( ar = sb->art; ar != 0 ; ar=ar->next){
	if ( ar->flag == 0 ){	/* ̤ */
	  ar->flag = 1;
	  change = 1;
	}
      }
      sb->numb = 0;
      return(QUIT);
    case 'l':
      if ( (disp_mode & THREADED) == 0 ) {
	article_make_thread(sb);
	disp_mode |= THREADED;
	sb->flag |= THREADED;
      } else {
	article_make_order(sb);
	disp_mode &= ~THREADED;
	sb->flag &= ~THREADED;
      }
      gn.autolist = 1;
      return(CONT);
    case 'q':			/* λ */
      return(QUIT);
    case '?':			/* help */
      article_mode_help();
      return(CONT);
    }
  }
  
  /* Ȥ륳ޥ */
  switch ( *pt ) {
  case 'p':			/*  */
    pt++;
    while (*pt == ' ')
      pt++;
    arg = atoi(pt);
    if ( arg <= 0 )
      top -= EFFECT_LINES;
    else
      top -= arg;
		
    if ( top < 0 )
      top = 0;
		
    gn.autolist = 1;
    return(CONT);
		
  case 'n':			/*  */
    pt++;
    while (*pt == ' ')
      pt++;
    arg = atoi(pt);
    if ( arg <= 0 )
      top += EFFECT_LINES;
    else
      top += arg;
		
    gn.autolist = 1;
    return(CONT);
#ifndef	NO_SAVE		
  case 's':			/*  */
    save_mode(pt);
    return(CONT);
#endif /* NO_SAVE */

  case 'U':			/* ɥޡä */
    article_unread(ar,pt);
    return(CONT);
		
#if ! defined(QUICKWIN) && ! defined(WINDOWS)
#ifndef	NO_SHELL
  case '!':			/* SHELL */
    shell_mode(pt);
    return(CONT);
#endif /* NO_SHELL */
#ifndef	NO_PIPE
  case '|':			/* PIPE */
    pipe_mode(pt);
    return(CONT);
#endif /* NO_PIPE */
#endif /* ! QUICKWIN && ! WINDOWS */
  case '<':
    return(show_article_id(pt));
  case '/':			/* ƼԸ */
    article_search(pt);
    gn.autolist = 1;
    return(CONT);
  case '\\':			/* ƼԸʵս */
    article_search_rev(pt);
    gn.autolist = 1;
    return(CONT);
  default:
#ifdef	WINDOWS
    MessageBeep(MB_OK);
#else  /* WINDOWS */
    putchar(BEL);
#endif /* WINDOWS */
    return(CONT);
  }
}

/*
 * ̤ɵɽ
 */
#define	CHECK_COUNT	10
#ifndef	WINDOWS
int
article_all_article()
{
  extern int show_article_common();
  
#if ! defined(NO_NET)
  char resp[NNTP_STRLEN*2+1];
#endif
  register char *artilce_file;
  register article_t *ar;
  register int count = 0;
  char *key_buf;
  FILE *fp;
  
  for ( ar = sb->art; ar != 0 ; ar=ar->next) {
    if ( ar->flag )
      continue;
    if ( gn.local_spool ) {
      if ( gn.power_save == COPY_TO_TMP )
	artilce_file = expand_filename(article_filename(ar->numb),gn.tmpdir);
      else
	artilce_file = expand_filename(article_filename(ar->numb),ngdir);
      if ( artilce_file == 0 ) {
	mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",
		  article_filename(ar->numb));
	return(ARTICLE_NOT_FOUND);
      }
      if ( (fp = fopen(artilce_file,"r")) == NULL ) {
	mc_puts(article_not_found);
	hit_return();
	return(ARTICLE_NOT_FOUND);
      }
#if ! defined(NO_NET)
    } else {
      sprintf(resp,"ARTICLE %ld",ar->numb);
      if ( put_server(resp) )
	return(CONNECTION_CLOSED);
      if ( get_server(resp,NNTP_STRLEN*2) )
	return(CONNECTION_CLOSED);
      switch ( atoi(resp) ) {
      case OK_ARTICLE:
	break;
      case ERR_NOARTIG:
	mc_puts(article_not_found);
	hit_return();
	return(CONT);
      default:
	return(CONNECTION_CLOSED);
      }
#endif /* NO_NET */
    }

    switch ( show_article_common(ng,ar->numb,fp,artilce_file) ) {
    case CONNECTION_CLOSED:
      return(CONNECTION_CLOSED);
    case FILE_WRITE_ERROR:
      mc_puts("ƥݥեκ˼Ԥޤ\n");
      return(CONT);
    case ARTICLE_NOT_FOUND:
      return(CONT);
    case SELECT:
      /* ̤ɤʤɤ */
      if ( ar->flag == 0 ) {
	ar->flag = 1;
	sb->numb--;
      }
      return(SELECT);
    case CONT:
      /* ̤ɤʤɤ */
      if ( ar->flag == 0 ) {
	ar->flag = 1;
	sb->numb--;
      }
      break;
    default:
      break;
    }

    if ( ++count >= CHECK_COUNT && ar->next != 0) {
      key_buf = kb_input("³ޤ:n");
      while( *key_buf == ' ' || *key_buf == '\t' )
	key_buf++;
      if ( *key_buf == 'n' || *key_buf == 'N' )
	return(CONT);
      count = 0;
    }
  }
  return(CONT);
}
#else	/* WINDOWS */
article_all_article()
{
  extern int show_article();
  static int count = 0;
  register  article_t *ar = 0;
  
  for (ar = sb->art ; ar != 0 ; ar=ar->next) {
    if ( ar->flag == 0)
      break;
  }
  if ( ar == 0 ) {
    count = 0;
    PostMessage(hWnd, WM_SUBJECTMODE,0 , 0L);
    return(END);
  }
  
  if ( ++count >= CHECK_COUNT && ar->next != 0) {
    if ( mc_MessageBox(hWnd,"³ޤ",
		       "",MB_OKCANCEL) == IDCANCEL ){
      count = 0;
      PostMessage(hWnd, WM_ARTICLEMODE,0 , 0L);
      return(END);
    }
    count = 0;
  }
  
  switch ( show_article(ar->numb) ){
  case CONNECTION_CLOSED:
    return(CONNECTION_CLOSED);
  case CONT:
  case SELECT:
    if ( ar->flag == 0 ) {
      ar->flag = 1;
      sb->numb--;
    }
    break;
  case FILE_WRITE_ERROR:
    mc_puts("ƥݥեκ˼Ԥޤ\n");
    return(END);
  }
  
  return(CONT);
}
#endif	/* WINDOWS */
static void
article_unread(ar,pt)
register article_t *ar;
char *pt;
{
  long num;
  char resp[NNTP_STRLEN*2+1];
  newsgroup_t *cng;
  subject_t *csb;
  char *ngname;
  long	artnum;
  
  pt++;
  while( *pt == ' ' || *pt == '\t' )
    pt++;
  
  if ( strcmp(last_art.newsgroups,ng->name) == 0 && (*pt<'0' || '9'<*pt )) {
#ifndef	WINDOWS
    sprintf(resp,
	    "̤ɤˤ뵭ֹϤƲʥǥե:%ld/:q",
	    last_art.art_numb);
    while (1) {
      pt = kb_input(resp);
      while( *pt == ' ' || *pt == '\t' )
	pt++;
      if ( *pt == 'q' )
	return;
      if ( ('0' <= *pt && *pt <= '9') || *pt == 0 )
	break;
    }
    if ( *pt == 0 )
      num = last_art.art_numb;
    else
      num = atol(pt);
#else  /* WINDOWS */
    sprintf(resp,
	    "̤ɤˤ뵭ֹϤƲʥǥե:%ld",
	    last_art.art_numb);
    while (1) {
      if ( (pt= kb_input(resp) ) == NULL )
	return;
      while( *pt == ' ' || *pt == '\t' )
	pt++;
      if ( '0' <= *pt && *pt <= '9' || *pt == 0 )
	break;
    }
    if ( *pt == 0 )
      num = last_art.art_numb;
    else
      num = atol(pt);
#endif /* WINDOWS */
  } else {
    while ( *pt < '0' || '9' < *pt ) {
#ifndef	WINDOWS
      pt = kb_input("̤ɤˤ뵭ֹϤƲ:q");
      while( *pt == ' ' || *pt == '\t' )
	pt++;
      if ( *pt == 'q' )
	return;
#else  /* WINDOWS */
      if ( (pt = kb_input("̤ɤˤ뵭ֹϤƲ")) == NULL )
	return;
      while( *pt == ' ' || *pt == '\t' )
	pt++;
#endif /* WINDOWS */
    }
    num = atol(pt);
  }
  
  if (strcmp(last_art.newsgroups,ng->name) == 0 && last_art.art_numb == num){
    strcpy(resp,last_art.xref);
    pt = resp;

    while ( *pt != 0 ) {
      ngname = pt;
      while ( *pt != ':' )
	pt++;
      *pt++ = 0;
      artnum = atol(pt);
      while ( ('0' <= *pt && *pt <= '9') || *pt == ' ')
	pt++;
      if ( (cng = search_group(ngname)) == 0 )
	continue;
      if ( cng == ng )
	continue;
      set_unreaded(cng,artnum);
    }
  }
  for ( csb = ng->subj ; csb != 0 ; csb = csb->next ) {
    for ( ar = csb->art; ar != 0 ; ar = ar->next) {
      if ( ar->numb == num ) {
	if ( ar->flag != 0 ) {
	  ar->flag = 0;
	  csb->numb++;
	  ng->flag &= ~NOARTICLE;
	  change = 1;
	}
	return;
      }
    }
  }
  
#ifdef	WINDOWS
  mc_MessageBox(hWnd,article_not_found,"",MB_OK);
#else	/* WINDOWS */
  mc_puts(article_not_found);
  hit_return();
#endif	/* WINDOWS */
}

/*
 * ɽ
 */
int
show_article(n)
long n;			/* ֹ */
{
  extern int show_article_common();
#if ! defined(NO_NET)
  char resp[NNTP_STRLEN*2+1];
#endif
  FILE *fp;
  register char *article_file;
  
  if ( gn.local_spool ) {
    if ( gn.power_save == COPY_TO_TMP )
      article_file = expand_filename(article_filename(n),gn.tmpdir);
    else
      article_file = expand_filename(article_filename(n),ngdir);
    if ( article_file == 0 ) {
#if ! defined(WINDOWS)
      mc_printf("ե̾Ÿ˼Ԥޤ(%s)\n",
		article_filename(n));
#else  /* WINDOWS */
      mc_MessageBox(hWnd,"ե̾Ÿ˼Ԥޤ",
		    article_filename(n),MB_OK);
#endif /* WINDOWS */
      return(ARTICLE_NOT_FOUND);
    }

    if ( (fp = fopen(article_file,"r")) == NULL ) {
#ifdef	WINDOWS
      mc_MessageBox(hWnd,article_not_found,"",MB_OK);
#else  /* WINDOWS */
      mc_puts(article_not_found);
      hit_return();
#endif /* WINDOWS */
      return(ARTICLE_NOT_FOUND);
    }
#if ! defined(NO_NET)
  } else {
#ifdef	WINDOWS
    set_hourglass();
#endif /* WINDOWS */
    sprintf(resp,"ARTICLE %ld",n);
    if ( put_server(resp) ) {
#ifdef	WINDOWS
      reset_cursor();
#endif /* WINDOWS */
      return(CONNECTION_CLOSED);
    }
    if ( get_server(resp,NNTP_STRLEN*2) ) {
#ifdef	WINDOWS
      reset_cursor();
#endif /* WINDOWS */
      return(CONNECTION_CLOSED);
    }
    switch ( atoi(resp) ) {
    case OK_ARTICLE:
      break;
    case ERR_NOARTIG:
#ifdef	WINDOWS
      reset_cursor();
      mc_MessageBox(hWnd,article_not_found,"",MB_OK);
#else  /* WINDOWS */
      mc_puts(article_not_found);
      hit_return();
#endif /* WINDOWS */
      return(ARTICLE_NOT_FOUND);
    default:
#ifdef	WINDOWS
      reset_cursor();
#endif /* WINDOWS */
      return(CONNECTION_CLOSED);
    }
#endif
  }
  return(show_article_common(ng,n,fp,article_file));
}

int
show_article_common(cng,numb,art_fp,art_file)
register newsgroup_t *cng;	/* ȥ˥塼롼ץꥹ */
long numb;			/* ֹ */
FILE *art_fp;			/* ե(only for local_spool) */
char *art_file;			/* ե̾(only for local_spool) */
{
  extern void add_esc();
#ifdef	QUICKWIN
  extern int qw_pager();
#endif	/* QUICKWIN */
#ifdef	WINDOWS
  extern void win_pager();
#endif	/* WINDOWS */
  
  FILE *fp;
  char resp[NNTP_STRLEN*2+1];
  char resp2[NNTP_STRLEN*2+1];
  char buf[NNTP_STRLEN*2+1];
  register char *sp,*pt;
  int x = 0;
  
#if ! defined(NO_NET)
  if ( gn.local_spool == 0 ) {
    /*  */
    if ( get_server(resp,NNTP_STRLEN*2)) {
#ifdef	WINDOWS
      reset_cursor();
#endif /* WINDOWS */
      return(CONNECTION_CLOSED);
    }
    if ( resp[0] == 0 ) {
#ifdef	WINDOWS
      reset_cursor();
      mc_MessageBox(hWnd,article_not_found,"",MB_OK);
#else  /* WINDOWS */
      mc_puts(article_not_found);
      hit_return();
#endif /* WINDOWS */
      while ( resp[0] != '.' || resp[1] != 0 ) {
	if ( get_server(resp,NNTP_STRLEN*2)) {
	  return(CONNECTION_CLOSED);
	}
      }
      return(ARTICLE_NOT_FOUND);
    }
  }
#endif
  /* ɤмΤƤ */
  if ( last_art.tmp_file[0] != 0 && make_article_tmpfile == ON )
    unlink(last_art.tmp_file);
  
  last_art.tmp_file[0] = 0;
  last_art.newsgroups[0] = 0;
  last_art.from[0] = 0;
  last_art.date[0] = 0;
  last_art.references[0] = 0;
  last_art.xref[0] = 0;
  last_art.art_numb = 0;
  last_art.lines = 0;
  
  if ( cng == 0 ) {
    last_art.newsgroups[0] = 0;
    last_art.art_numb = 0;
  } else {
    strcpy(last_art.newsgroups,cng->name);
    last_art.art_numb = numb;
  }
  
  if ( make_article_tmpfile != ON ) {
    strcpy(last_art.tmp_file,art_file);
  } else {
    /* ƥݥե˽ */
    strcpy(last_art.tmp_file,gn.tmpdir);
    strcat(last_art.tmp_file,"gnXXXXXX");
    mktemp(last_art.tmp_file);
    if ( ( fp = fopen(last_art.tmp_file,"w") ) == NULL ){
#ifdef	WINDOWS
      reset_cursor();
      mc_MessageBox(hWnd,"ƥݥեΥץ˼Ԥޤ",
		    last_art.tmp_file,MB_OK);
#else  /* WINDOWS */
      perror(last_art.tmp_file);
#endif /* WINDOWS */
      last_art.tmp_file[0] = 0;
#if ! defined(NO_NET)
      while ( resp[0] != '.' || resp[1] != 0 ) {
	if ( get_server(resp,NNTP_STRLEN*2))
	  return(CONNECTION_CLOSED);
      }
#endif
      return(FILE_WRITE_ERROR);
    }
  }
  
  if ( gn.local_spool ) {
    resp[0] = 0;
    get_1_header_file(buf,resp,art_fp);
  }
  
  /* إå */
  while(1) {
    if ( resp[0] == 0 ) {
      if ( make_article_tmpfile == ON )
	fprintf(fp,"\n");
      last_art.lines++;
      break;
    }
    /* ɤ߹ */
    if ( gn.local_spool ) {
      get_1_header_file(buf,resp,art_fp);
#if ! defined(NO_NET)
    } else  {
      if ( get_1_header(buf,resp) == CONNECTION_CLOSED ) {
#ifdef	WINDOWS
	reset_cursor();
#endif /* WINDOWS */
	return(CONNECTION_CLOSED);
      }
#endif
    }

    /* Newsgroups: إå */
    if ( cng == 0 ) {
      if ( strncmp(buf,"Newsgroups: ",12) == 0 ) {
	if ( make_article_tmpfile == ON ) {
	  if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	    fprintf(fp,"%s\n",buf);
	  } else {
	    kanji_fromspool(buf,resp2);
	    fprintf(fp,"%s\n",resp2);
	  }
	}
	last_art.lines++;
	if ( (sp = strchr(buf,',')) != 0 )
	  *sp = 0;
	strcpy(last_art.newsgroups,&buf[12]);
	continue;
      }
    }
    /* From: إå */
    if ( strncmp(buf,"From: ",6) == 0 ) {
#ifdef	MIME
      if ( (gn.mime_head & MIME_DECODE) != 0 ) {
	kanji_convert(gn.spool_kanji_code,buf,JIS,resp2);
	MIME_strHeaderDecode(resp2,buf,sizeof(buf));
	kanji_convert(JIS,buf,gn.process_kanji_code,resp2);
	if ( make_article_tmpfile == ON )
	  fprintf(fp,"%s\n",resp2);
	strcpy(last_art.from,&resp2[6]);
      } else
#endif
	if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	  if ( make_article_tmpfile == ON )
	    fprintf(fp,"%s\n",buf);
	  strcpy(last_art.from,&buf[6]);
	} else {
	  kanji_fromspool(buf,resp2);
	  if ( make_article_tmpfile == ON )
	    fprintf(fp,"%s\n",resp2);
	  strcpy(last_art.from,&resp2[6]);
	}

      last_art.lines++;
      if ( (sp = strchr(last_art.from,'(')) != NULL )
	*sp= 0;
      continue;
    }

    /* Date: إå */
    if ( strncmp(buf,"Date: ",6) == 0 ) {
      if ( gn.gmt2jst == ON ) {	/* GMT -> JST */
	if ( gmt_to_jst(&buf[6],resp2) == 0 )
	  strcpy(&buf[6],resp2);
      }
      if ( make_article_tmpfile == ON ) {
	if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	  fprintf(fp,"%s\n",buf);
	} else {
	  kanji_fromspool(buf,resp2);
	  fprintf(fp,"%s\n",resp2);
	}
      }
      last_art.lines++;
      strcpy(last_art.date,&buf[6]);
      continue;
    }
    /* References: إå */
    if ( strncmp(buf,"References: ",12) == 0 ) {
      if ( make_article_tmpfile == ON ) {
	if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	  fprintf(fp,"%s\n",buf);
	} else {
	  kanji_fromspool(buf,resp2);
	  fprintf(fp,"%s\n",resp2);
	}
      }
      last_art.lines++;
      strcpy(last_art.references,&buf[12]);
      continue;
    }
    /* X-Nsubject: إå */
    if ( strncmp(buf,"X-Nsubject: ",12) == 0 ) {
      add_esc(buf,resp2);
      if ( make_article_tmpfile == ON ) {
	if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	  fprintf(fp,"%s\n",resp2);
	} else {
	  kanji_fromspool(resp2,buf);
	  fprintf(fp,"%s\n",buf);
	}
      }
      last_art.lines++;
      continue;
    }
    /* Xref: إå */
    if ( strncmp(buf,"Xref: ",6) == 0 ) {
      if ( make_article_tmpfile == ON ) {
	if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	  fprintf(fp,"%s\n",buf);
	} else {
	  kanji_fromspool(buf,resp2);
	  fprintf(fp,"%s\n",resp2);
	}
      }
      last_art.lines++;
      if ( (pt = strchr(&buf[6],' ')) == NULL )
	continue;
      pt++;			/* ۥ̾ѥ */
      strcpy(last_art.xref,pt);
      continue;
    }

    /* other */
#ifdef	MIME
    if ( (gn.mime_head & MIME_DECODE) != 0 ) {
      kanji_convert(gn.spool_kanji_code,buf,JIS,resp2);
      MIME_strHeaderDecode(resp2,buf,sizeof(buf));
      kanji_convert(JIS,buf,gn.process_kanji_code,resp2);
      if ( make_article_tmpfile == ON )
	fprintf(fp,"%s\n",resp2);
    } else
#endif
      if ( make_article_tmpfile == ON ) {
	if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	  fprintf(fp,"%s\n",buf);
	} else {
	  kanji_fromspool(buf,resp2);
	  fprintf(fp,"%s\n",resp2);
	}
      }
    last_art.lines++;
  }
  
  /*  */
  while(1) {
    if ( ++x > 20 ){
      mc_printf(".");
      fflush(stdout);
      x = 0;
#ifdef	QUICKWIN
      _wyield();
#endif
    }
    /* ɤ߹ */
    if ( gn.local_spool ) {
      if ( fgets(resp,NNTP_STRLEN*2,art_fp) == NULL ) {
	fclose(art_fp);
	break;
      }
      if ( (pt = strchr(resp,'\n')) != NULL)
	*pt = 0;
#if ! defined(NO_NET)
    } else {
      if ( get_server(resp,NNTP_STRLEN*2)) {
#ifdef	WINDOWS
	reset_cursor();
#endif /* WINDOWS */
	return(CONNECTION_CLOSED);
      }
      if ( resp[0] == '.' && resp[1] == 0)
	break;
#endif
    }
    /* Ѵ */
    if ( make_article_tmpfile == ON ) {
      if ( gn.process_kanji_code == gn.spool_kanji_code ) {
	if ( gn.local_spool == 0 && resp[0] == '.' && resp[1] == '.' ) {
	  fprintf(fp,"%s\n",&resp[1]);
	} else {
	  fprintf(fp,"%s\n",resp);
	}
      } else {
	if ( gn.local_spool == 0 && resp[0] == '.' && resp[1] == '.')
	  kanji_fromspool(&resp[1],resp2);
	else
	  kanji_fromspool(resp,resp2);
	fprintf(fp,"%s\n",resp2);
      }
    }
    last_art.lines++;
  }
  
  if ( make_article_tmpfile == ON ) {
    if ( fclose(fp) == EOF ) {
#ifdef	WINDOWS
      reset_cursor();
#endif /* WINDOWS */
      return(FILE_WRITE_ERROR);
    }
  }

#ifdef	WINDOWS
  reset_cursor();
  win_pager(last_art.tmp_file,last_art.lines);
  if ( cng != 0 && last_art.xref[0] != 0 )
    xref_mark(last_art.xref,cng->name);
  return(SELECT);
#else	/* WINDOWS */
#ifdef	QUICKWIN
  qw_pager(last_art.tmp_file);
  if ( cng != 0 && last_art.xref[0] != 0 )
    xref_mark(last_art.xref,cng->name);
  return(CONT);
#else	/* QUICKWIN */
  sprintf(resp,"%s %s",gn.pager,last_art.tmp_file);
  system(resp);
  if ( cng != 0 && last_art.xref[0] != 0 )
    xref_mark(last_art.xref,cng->name);
  if ( gn.return_after_pager != 0 )
    hit_return();
  return(CONT);
#endif	/* QUICKWIN */
#endif	/* WINDOWS */
}

/* GMT  JST Ѵ                                     */
/* [day, ]dd mm yy GMT/+0000/UT/Z Ȥ format ʳ̵뤹 */
/*    0: ѴѤ                                        */
/*         -1: Ѵʤä                                  */

static char *daystr[]
	= {"Sun, ","Mon, ","Tue, ","Wed, ","Thu, ","Fri, ","Sat, "};
static char *monthstr[]
	= {"Jan ","Feb ","Mar ","Apr ","May ","Jun ",
		   "Jul ","Aug ","Sep ","Oct ","Nov ","Dec "};
static int
gmt_to_jst(gmt,jst)
char *gmt;
char *jst;
{
  int  hour,date,month,year,day;
  int  flag,i;
  char *gmt_p;
  char ms[6];
  char str[5];
  
  gmt_p = gmt;
  if (strncmp(&gmt[3],", ",2))
    day = 7;	/* ʤ */
  else {
    gmt_p += 5;
    for (day=7,flag=0,i=0;i<7;i++) {
      if (!strncmp(gmt,daystr[i],5)) {
	day = i;
	flag = 1;
	break;
      }
    }
    if (!flag)
      return(-1);		/*  format ۾ */
  }
  
  if (isdigit(*(gmt_p++))) {
    if (*gmt_p == ' ') {	/*  1 */
      date = *(--gmt_p) - 0x30;
      gmt_p += 2;
    }
    else if (isdigit(*gmt_p)) {
      date = *(gmt_p--) - 0x30;	/*  2 */
      date += (*gmt_p - 0x30) * 10;
      gmt_p += 3;
    }
    else
      return(-1);		/*  format ۾ */
  }
  else
    return(-1);		/*  format ۾ */
  
  for (flag=0,i=0;i<12;i++) {
    if (!strncmp(gmt_p,monthstr[i],4)) {
      month = i + 1;
      flag = 1;
      break;
    }
  }
  if (!flag)
    return(-1);		/*  format ۾ */
  gmt_p += 4;
  
  if (isdigit(*gmt_p++)&&isdigit(*gmt_p++)) {
    if (*gmt_p == ' ') {
      gmt_p -= 2;
      year = (*(gmt_p++) - 0x30) * 10;
      year += (*gmt_p - 0x30);
    }
    else if (isdigit(*gmt_p++)&&isdigit(*gmt_p++)&&(*gmt_p == ' ')) {
      gmt_p -= 4;
      year = (*(gmt_p++) - 0x30) * 1000;
      year += (*(gmt_p++) - 0x30) * 100;
      year += (*(gmt_p++) - 0x30) * 10;
      year += (*gmt_p - 0x30);
    }
    else
      return(-1);		/* ǯ format ۾ */
  }
  else
    return(-1);	/* ǯ format ۾ */
  gmt_p += 2;
  
  if (isdigit(*(gmt_p++))&&isdigit(*(gmt_p++))&&(*gmt_p == ':')) {
    gmt_p -= 2;
    hour = (*gmt_p - 0x30) * 10;
    hour += *(++gmt_p) - 0x30;
    gmt_p += 2;
  }
  else
    return(-1);	/*  format ۾ */
  
  if (isdigit(*(gmt_p++))&&isdigit(*(gmt_p--))) {
    ms[0] = *gmt_p++;
    ms[1] = *gmt_p++;
  }
  else
    return(-1);	/* ʬ format ۾ */
  
  if (*gmt_p == ':') {
    gmt_p++;
    if (isdigit(*(gmt_p++))&&isdigit(*(gmt_p++))&&(*gmt_p == ' ')) {
      gmt_p -= 2;
      ms[2] = ':';
      ms[3] = *(gmt_p++);
      ms[4] = *gmt_p++;
      ms[5] = '\0';
      if ((strncmp(gmt_p," GMT",4))&&(strncmp(gmt_p," +0000",6))
	  &&(strncmp(gmt_p," -0000",6))&&(strncmp(gmt_p," UT",3))
	  &&(strncmp(gmt_p," Z",2)))
	return(-1);		/* GMT ʳ */
    }
    else
      return(-1);		/*  format ۾ */
  }
  else if (*gmt_p == ' ') {
    if ((strncmp(gmt_p," GMT",4))&&(strncmp(gmt_p," +0000",6))
	&&(strncmp(gmt_p," -0000",6))&&(strncmp(gmt_p," UT",3))
	&&(strncmp(gmt_p," Z",2)))
      return(-1);		/* GMT ʳ */
    else {
      gmt_p -= 2;
      ms[2] = '\0';
    }
  }
  else
    return(-1);	/*  format ۾ */
  
  hour += 9;
  if (hour > 23) {
    hour -= 24;
    date ++;
    if (day != 7) {
      if (day == 6)
	day = 0;
      else
	day++;
    }
    switch (month) {
    case 1:
      if (date == 32) {
	month = 2;
	date = 1;
      }
      break;
    case 2:
      for (flag=1;;) {
	if (year%4)
	  break;
	else if (!(year%100))
	  if (year%400)
	    break;
	if (date == 30) {
	  month = 3;
	  date = 1;
	}
	flag = 0;
	break;
      }
      if (flag) {
	if (date == 29) {
	  month = 3;
	  date = 1;
	}
      }
      break;
    case 3:
      if (date == 32) {
	month = 4;
	date = 1;
      }
      break;
    case 4:
      if (date == 31) {
	month = 5;
	date = 1;
      }
      break;
    case 5:
      if (date == 32) {
	month = 6;
	date = 1;
      }
      break;
    case 6:
      if (date == 31) {
	month = 7;
	date = 1;
      }
      break;
    case 7:
      if (date == 32) {
	month = 8;
	date = 1;
      }
      break;
    case 8:
      if (date == 32) {
	month = 9;
	date = 1;
      }
      break;
    case 9:
      if (date == 31) {
	month = 10;
	date = 1;
      }
      break;
    case 10:
      if (date == 32) {
	month = 11;
	date = 1;
      }
      break;
    case 11:
      if (date == 31) {
	month = 12;
	date = 1;
      }
      break;
    default:
      if (date == 32) {
	month = 1;
	date = 1;
	year++;
      }
    }
  }
  
  jst[0] = '\0';
  if (day != 7)
    strcat(jst,daystr[day]);
  
  if (date/10) {
    str[0] = date/10 + 0x30;
    str[1] = date%10 + 0x30;
    str[2] = '\0';
  }
  else {
    str[0] = date%10 + 0x30;
    str[1] = '\0';
  }
  strcat(jst,str);
  strcat(jst," ");
  
  strcat(jst,monthstr[month-1]);
  
  i = 0;
  if (year/1000) {
    str[i++] = year/1000 + 0x30;
    year -= (year/1000) * 1000;
    str[i++] = year/100 + 0x30;
    year -= (year/100) * 100;
  }
  str[i++] = year/10 + 0x30;
  str[i++] = year%10 + 0x30;
  str[i] = '\0';
  strcat(jst,str);
  strcat(jst," ");
  
  str[0] = hour/10 + 0x30;
  str[1] = hour%10 + 0x30;
  str[2] = ':';
  str[3] = '\0';
  strcat(jst,str);
  
  strcat(jst,ms);
  
  strcat(jst," JST");
  return(0);
}

#ifdef	QUICKWIN
int
qw_pager(file_name)
char *file_name;
{
  FILE *wp;
  FILE *rp;
  struct _wopeninfo wopen;
  struct _wsizeinfo wsize;
  char resp[NNTP_STRLEN*2];
  FILE *fp;
  int x;
  
  wopen._version = _QWINVER;
  sprintf(resp,"%s:%ld",last_art.newsgroups,last_art.art_numb);
  wopen._title = resp;
  wopen._wbufsize = _WINBUFDEF;
  
  wsize._version = _QWINVER;
  wsize._type = _WINSIZEMAX;
  
  /* ɥΥץ */
  if ( (wp = _fwopen( &wopen, &wsize, "w" )) == NULL ) {
    mc_puts("ڡ㤬¹ԤǤޤ \n");
    return(-1);
  }
  
  if ( (rp = _fdopen(_fileno(wp),"r")) == NULL  ) {
    mc_puts("ڡ㤬¹ԤǤޤ \n");
    return(-1);
  }
  
  if( _wgetsize( _WINFRAMEHAND, _WINCURRREQ, &wsize ) == -1 ) {
    mc_puts("ڡ㤬¹ԤǤޤ \n");
    return(-1);
  }
  gn.lines = wsize._h;
  gn.columns = wsize._w;
  
  if ( (fp = fopen(file_name,"r")) == NULL ) {
    return(-1);
  }
  
  x = 0;
  while (1) {
    if (fgets(resp,NNTP_STRLEN*2,fp) == NULL ) {
      fprintf(wp,"end:");
      fflush(wp);
      fgets(resp,NNTP_STRLEN*2,rp);
      break;
    }
    fprintf(wp,"%s", resp);

    if ( ++x >= gn.lines - 1 ) {
      fprintf(wp,":");
      fflush(wp);
      fgets(resp,NNTP_STRLEN*2,rp);
      if ( resp[0] == 'q' )
	break;
      x = 0;
    }
  }
  fclose(fp);
  
  fclose(rp);
  _wclose( _fileno( wp ), _WINNOPERSIST );
  
  return(0);
}
#endif	/* QUICKWIN */
#ifdef	WINDOWS

static FILE *fp;
static long	pager_start,pager_end;	/* 1 orig. */
static int pager_eof;
static int ikc;	/* internal_kanji_code */
void
win_pager(tmp_file,lines)
char *tmp_file;
int lines;
{
  static gnpopupmenu_t pagermode_file_menu[] = {
    { "ڡ㽪λ(\036Q)",
	IDM_PAGQUIT,			0 },
    { 0,0,0 }
  };
  
  static gnpopupmenu_t pagermode_view_menu[] = {
    { "̤ɽ(\036B)",
	IDM_PAGBACK,			0 },
    { "̤ɽ(\036 )",
	IDM_PAGCONT,			0 },
    { "Ծɽ(\036K)",
	IDM_PAGK,				0 },
    { "Բɽ(\036J)",
	IDM_PAGONE,			0 },
    { "Ǹɽ(\036G)",
	IDM_PAGBOTTOM,		0 },
    { 0,0,0 }
  };
  
  static gnpopupmenu_t pagermode_help_menu[] = {
    { "С(\036A)...",
	IDM_ABOUT, 			0 },
    { 0,0,0 }
  };
  
  static gnmenu_t pagermode_menu[] = {
    { "ե(\036F)",	pagermode_file_menu },
    { "ɽ(\036V)",		pagermode_view_menu },
    { "إ(\036H)",		pagermode_help_menu },
    { 0,0 }
  };
  
  setmenu(pagermode_menu);
  
  fp = fopen(tmp_file,"r");
  pager_start = pager_end = 0L;
  pager_eof = 0;
  
  SetScrollRange(hWnd,SB_VERT,0,lines,FALSE);
  SetScrollPos(hWnd,SB_VERT,0,TRUE);
  
  PostMessage(hWnd, WM_PAGER,0 , 0L);
}
void
win_pager_key(c)
char c;
{
  extern void win_pager_cont(),win_pager_one(),win_pager_back();
  extern void win_pager_k(),win_pager_bottom();
  
  switch ( c ) {
  case ' ':
    if ( ( gn.win_pager_flag & 1 ) != 0 && pager_eof == ON) {
      MessageBeep(MB_OK);
      break;
    }
    win_pager_cont();
    break;
  case '\r':
  case '\n':
  case 'j':
    if ( ( gn.win_pager_flag & 1 ) != 0 && pager_eof == ON) {
      MessageBeep(MB_OK);
      break;
    }
    win_pager_one();
    break;
  case 'b':
    win_pager_back();
    break;
  case 'k':
    win_pager_k();
    break;
  case 'G':
    win_pager_bottom();
    break;
  case 'q':
    PostMessage(hWnd,WM_PAGER_END,0,0L);
    break;
  }
}
void
win_pager_cont()
{
  char resp[NNTP_STRLEN*2+1];
  
  if ( pager_eof == ON ) {
    PostMessage(hWnd, WM_PAGER_END,0 , 0L);
    return;
  }
  
  
  ikc = internal_kanji_code;
  internal_kanji_code = SJIS;
  
  pager_start = pager_end + 1L;
  SetScrollPos(hWnd,SB_VERT,(int)pager_end,TRUE);
  
  fast_mc_puts_start();
  while ( ypos < (gn.lines-1) ) {
    pager_end ++;
    if (fgets(resp,NNTP_STRLEN*2,fp) == NULL ) {
      while ( ypos < (gn.lines-1))
	mc_puts("~\n");
      mc_puts("end:");
      pager_eof = ON;
      fast_mc_puts_end();
      internal_kanji_code = ikc;
      return;
    }
    if ( resp[0] == FF && resp[1] == NL ) {
      mc_puts("^L\n");
      while ( ypos < (gn.lines-1))
	mc_puts("~\n");
      break;
    }
    mc_puts(resp);
  }
  mc_puts(":");
  fast_mc_puts_end();
  internal_kanji_code = ikc;
}
void
win_pager_redraw()
{
  void win_pager_line();
  
  win_pager_line(pager_start);
}
/* b:back */
void
win_pager_back()
{
  void win_pager_line();
  long back_start;
  
  if ( pager_start == 1 ) {
    MessageBeep(MB_OK);
    return;
  }
  
  back_start = pager_start - gn.lines;
  if ( back_start <= 0 )
    back_start = 1;
  
  win_pager_line(back_start);
}
/* k */
void
win_pager_k()
{
  void win_pager_line();
  long back_start;
  
  if ( pager_start == 1 ) {
    MessageBeep(MB_OK);
    return;
  }
  
  back_start = pager_start - 1;
  if ( back_start <= 0 )
    back_start = 1;
  
  win_pager_line(back_start);
}
void
win_pager_line(start_line)
long start_line;	/* Ϲ 1 orig. */
{
  char resp[NNTP_STRLEN*2+1];
  
  pager_eof = 0;
  
  rewind(fp);
  
  pager_end = start_line - 1L;
  
  while ( --start_line > 0L )
    fgets(resp,NNTP_STRLEN*2,fp);
  win_pager_cont();
}

/* CR 򲡤Ԥɽ */
void
win_pager_one()
{
  char resp[NNTP_STRLEN*2+1];
  
  if ( pager_eof == ON ) {
    PostMessage(hWnd, WM_PAGER_END,0 , 0L);
    return;
  }
  pager_start++;
  pager_end++;
  SetScrollPos(hWnd,SB_VERT,(int)pager_start-1,TRUE);
  
  xpos = 0;
  mc_puts(" ");
  xpos = 0;
  if (fgets(resp,NNTP_STRLEN*2,fp) == NULL ) {
    mc_puts("end:");
    pager_eof = ON;
    return;
  }
  
  ikc = internal_kanji_code;
  internal_kanji_code = SJIS;
  mc_puts(resp);
  internal_kanji_code = ikc;
  mc_puts(":");
}
void
win_pager_bottom()
{
  char resp[NNTP_STRLEN*2+1];
  register long l;
  
  rewind(fp);
  
  l = 0;
  while ( fgets(resp,NNTP_STRLEN*2,fp) != NULL )
    l++;
  
  win_pager_line(l-gn.lines+2);
  
  while ( pager_eof != ON )
    win_pager_one();
}
void
win_pager_end()
{
  fclose(fp);
  pager_start = pager_end = 0L;
  pager_eof = 0;
}
#endif	/* WINDOWS */
static void
xref_mark(last_xref,cng)
register char *last_xref,*cng;
{
  extern void set_readed();
  
  char xref_buf[NNTP_STRLEN*2+1];
  register char *ng_name, *pt, *xref;
  long art_num;
  register newsgroup_t *group;
  
  strcpy(xref_buf,last_xref);
  xref = xref_buf;
  
  while (1) {
    if ( *xref == ' ' || *xref == '\t' ){
      xref++;
      continue;
    }
    ng_name = xref;		/* ˥塼롼̾ */
    if ( (pt = strchr(ng_name,':')) == NULL )
      break;
    *pt = 0;
    pt++;
    art_num=atol(pt);		/* ֹ */
    xref = pt;
    while('0' <= *xref && *xref <= '9' )
      xref++;

    if ( strcmp(ng_name,cng) == 0 ) /* Ƥ˥塼롼 */
      continue;
    if (( group = search_group(ng_name)) == 0 )
      continue;			/* 롼פ¸ߤʤ */

    set_readed(group,art_num);
  }
}

/*
 * Ƚ˵¤Ѥ
 */
void
article_make_thread(sbj)
subject_t *sbj;
{
  article_t *temptop;
  register article_t **art;
  article_t **ars;
  register char *message_id;
  
  temptop = sbj->art;
  sbj->art = 0;
  ars = &(sbj->art);
  
  while ( temptop != 0 ){
    if ( temptop->next == 0 ) { /* Ĥ꤬ */
      /* subject queue ˤĤʤ */
      *ars = temptop;
      break;
    }

    art = &temptop;
    while (1) {			/* Ȥʤεõ */
      if ((*art)->reference == 0 ||
	  search_ref(temptop,(*art)->reference) == 0 ){	/* Ȥʤ */
	message_id = (*art)->message_id;
	/* subject queue ˤĤʤ */
	*ars = *art;
	*art = (*art)->next;
	ars = &((*ars)->next);
	*ars = 0;
	/* Ҷõ */
	search_child(&temptop,message_id,&ars,1);
	break;
      }
      if ( (*art)->next == 0 )
	break;			/* M-ID -- Ref: X-< */
      art = &((*art)->next);
    }
  }
}
static int
search_ref(ar,message_id)
register article_t *ar;
register char *message_id;
{
  for ( ; ar != 0 ; ar=ar->next){
    if ( strcmp(ar->message_id,message_id) == 0)
      return(1);		/* ȵ塼ˤ */
  }
  return(0);	/* ʤ */
}
static void
search_child(temptop,message_id,ars,level)
register article_t **temptop;
register char *message_id;
register article_t ***ars;
int level;
{
  register article_t **ar;
  register char *mes,*from;
  
  for (ar = temptop ; *ar != 0 ; ){
    if ((*ar)->reference != 0 && strcmp((*ar)->reference,message_id) == 0) {
      mes = (*ar)->message_id;

      /* ǥ */
      from = (char *)malloc(strlen((*ar)->from)+level+1);
      memset(from,' ',level);
      strcpy(&from[level],(*ar)->from);
      free((*ar)->from);
      (*ar)->from = from;
      /* 塼ΤĤʤľ */
      **ars = *ar;
      *ar = (*ar)->next;
      *ars = &((**ars)->next);
      **ars = 0;
      /* ˻Ҷõ */
      search_child(temptop,mes,ars,level+1);
      ar = temptop;
      continue;
    }
    ar = &((*ar)->next);
  }
}


/*
 * ֹ˵¤Ѥ
 */
void
article_make_order(sbj)
subject_t *sbj;
{
  article_t *temptop;
  register article_t **art,**ars, *sv;
  long art_no;
  register char *from,*wk;
  
  temptop = sbj->art;
  sbj->art = 0;
  
  while ( temptop != 0 ){
    art_no = 0;
    /* 礭ʵֹõ */
    for ( art = &temptop; *art != 0; art = &((*art)->next)){
      if ( art_no < (*art)->numb ) {
	art_no = (*art)->numb;
	ars = art;
      }
    }
    /* 塼ƬˤĤʤ */
    sv = (*ars)->next;
    (*ars)->next = sbj->art;
    sbj->art = *ars;
    *ars = sv;

    /* ǥȤ᤹ */
    from = sbj->art->from;
    while ( *from == ' ' )
      from++;
    wk = (char *)malloc(strlen(from)+1);
    strcpy(wk,from);
    free(sbj->art->from);
    sbj->art->from = wk;
  }
}

/*
 * ƼԸ
 */
static void
article_search(pt)
char *pt;
{
  register int i;
  register article_t *ar;
  
  if ( kb_search(sea_artname, pt) == QUIT )
    return;
  
  for ( i = 0 ,ar = sb->art; i < top && ar != 0 ; i++,ar=ar->next)
    ;
  for (  ; ar != 0 ; ar = ar->next,i++) {
    if( i != top && sregcmp(ar->from,sea_artname) ) {
      top = i;
      return;
    }
  }
  
  mc_printf("ʸ \"%s\" ϡޤ \007\n",sea_artname);
}
/*
 * ƼԸʵս
 */
static void
article_search_rev(pt)
char *pt;
{
  register int i,tmptop;
  register article_t *ar;
  
  if (kb_search(sea_artname, pt) == QUIT )
    return;
  
  tmptop = -1;
  for ( i = 0 ,ar = sb->art; i < top && ar != 0 ; i++,ar=ar->next) {
    if( sregcmp(ar->from,sea_artname) )
      tmptop = i;
  }
  
  if ( tmptop == -1 ) {
    mc_printf("ʸ \"%s\" ϡޤ \007\n",sea_artname);
  } else {
    top = tmptop;
  }
}
void
article_mode_help()
{
  static char *os = (char *)OS;
  static struct help_t help_tbl[] = {
    { "ƥ⡼", 0 },
    { "",0 },
    { "<CR>Τ      :ǽ̤ɵ ", 0 },
    { "<CR>      :ꤷֹε ", 0 },
    { "a<CR>         :̤ɤ ", 0 },
    { "p []<CR>    :̡ʤ⤷ϻꤷˤɽ ", 0 },
    { "n []<CR>    :̡ʤ⤷ϻꤷˤɽ ", 0 },
    { "t<CR>         :ĹԤޤʤɽ롿ʤʥȥ", 0 },
    { "P<CR>         :Υ֥ ", 0 },
    { "N<CR>         :Υ֥ ", 0 },
    { "i<CR>         :ߤΥ롼פصݥȤ ", 0 },
    { "ɣ<CR>      :ꤷåɣĤεɽ ", 0 },
    { "R<CR>         :Ǹɤθɽ ", 0 },
    { "f<CR>         :Ǹɤ˥եФ ", 0 },
    { "r<CR>         :Ǹɤ˥ץ饤ᥤФ ", 0 },
    { "C<CR>         :Ǹɤ򥭥󥻥뤹 ", 0 },
#ifndef	NO_SAVE
    { "s [file]<CR>  :Ǹɤե¸ ", 0 },
#endif /* NO_SAVE */
#if ! defined(QUICKWIN) && ! defined(WINDOWS)
#ifndef	NO_PIPE
    { "| [cmd]<CR>   :Ǹɤ򥳥ޥɤϤ ", 0 },
#endif /* NO_PIPE */
#endif /* ! QUICKWIN && ! WINDOWS */
    { "m<CR>         :ᥤ ", 0 },
    { "u<CR>         :Υ롼פϤ⤦ɤޤʤ ", 0 },
    { "S<CR>         :Υ롼פϤäѤɤ ", 0 },
    { "c<CR>         :̤ɤεɤȤˤ ", 0 },
    { "l<CR>         :Ƚɽ롿ʤʥȥ ", 0 },
    { "U [No.]<CR>   :ꤷֹε̤ɤˤ ", 0 },
    { "/ [ʸ]<CR>:ʸˤƼԸ ", 0 },
    { "\\ [ʸ]<CR>:ʸˤƼԵո ", 0 },
#if ! defined(QUICKWIN) && ! defined(WINDOWS)
#ifndef	NO_SHELL
    { "! [cmd]<CR>   :%s ޥɤ¹Ԥ ",&os },
#endif /* NO_SHELL */
#endif /* ! QUICKWIN && ! WINDOWS */
    { "q<CR>         :֥ȥ⡼ɤ ", 0 },
    { "?<CR>         :Υإ ", 0 },
#ifdef WINDOWS
    { "",0 },
    { "ƼɽξǺܥ֥륯å  :ε ",0 },
    { "ƼɽΤʤȤǺܥ󥯥å:ǽ̤ɵ ",0 },
    { "ܥ󥯥å                        :֥ȥ⡼ɤ",0 },
#endif /* WINDOWS */
    { 0,0 }
  };
  
  gn_help(help_tbl);
}
