/*
 * @(#)fgets.c	1.30 Apr.28,1994
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * Copyright (C) yamasita@omronsoft.co.jp
 *     + inouet@strl.nhk.or.jp  Aug.19.1993
 */

#ifdef USE_FGETS 

#include	<stdio.h>
#include	<ctype.h>
#ifdef MSDOS
#	include	<conio.h>
#	include	<stdlib.h>
#else
#	include	<sys/ioctl.h>
#	ifdef	SYSV_TERMIO
#		include	<sys/termio.h>
#	endif
#	define	exit(n) Exit(n)
#endif

#define DEL 0x7f

char *
Fgets(s, n, stream)
char *s;
int n;
FILE *stream;
{
	int c;
	char *fp;
#ifndef MSDOS
#ifdef	SYSV_TERMIO
	struct termio sgo, sgn;
#else
	struct sgttyb sgo, sgn;
#endif
#endif

	if (stream != stdin){
		fputs("Fgets: Bad stream\n",stdout);
		exit(1);
	}

	n--;
#ifndef MSDOS
#ifdef	SYSV_TERMIO
	ioctl(fileno(stdin), TCGETA, &sgo);
	sgn = sgo;
	sgn.c_iflag &=~(/* INLCR |*/ ICRNL  | IUCLC | ISTRIP | IXON | IXOFF);
	sgn.c_lflag &=~(ISIG | ICANON | XCASE | ECHO | ECHOE | ECHOK | ECHONL);
	sgn.c_oflag = OPOST;
/*	sgn.c_cc[VINTR] = CDEL;	*/
/*	sgn.c_cc[VQUIT] = CDEL;	*/
/*	sgn.c_cc[VERASE] = CDEL;	*/
/*	sgn.c_cc[VKILL] = CDEL;	*/
	sgn.c_cc[VEOF] = 1;
	sgn.c_cc[VMIN] = 1;
	sgn.c_cc[VEOL] = 0;
	sgn.c_cc[VTIME] = 0;
	sgn.c_cc[VSWTCH] = CDEL;
	if (ioctl (fileno(stdin), TCSETAW, &sgn) < 0){
		perror("Fgets: ioctl");
		exit(0);
	}
#else
	ioctl(0, TIOCGETP, &sgo);
	sgn = sgo;
	sgn.sg_flags &= ~ECHO;
	sgn.sg_flags |= RAW;
	if (ioctl(0, TIOCSETP, &sgn) < 0){
		perror("Fgets: ioctl");
		exit(0);
	}
#endif
#endif

	fp = (char*)s;
	do{
#ifdef MSDOS
		c = getch() & 0x00ff;
		if ((c == '\b')||(c == DEL)){
#else
		c = getc(stream) & 0x00ff;
#ifdef	SYSV_TERMIO
		if ((c == sgo.c_cc[VERASE])||(c == DEL)){
#else
		if ((c == sgo.sg_erase)||(c == DEL)){
#endif
#endif
			if (fp != (char*)s) {
				printf("\b \b");
				if (iscntrl(*(fp-1)))
					printf("\b \b");
				fp--; n++;
				*fp = '\0';
			}
		} else {
			if (c == '\n')
				c = '\r';	/* for Openwindows cmdtool */
			switch(c){
			case EOF:
				break;
			case ' ':
				if (fp == (char*)s)
					c='\r';
			default:
				*fp = c;
				if (iscntrl(c) && (c != '\r')){
					putchar('^'); putchar(c+'A'-1);
				}else
					putchar(c);
				fp++;
				*fp = '\0';
				n--;
				break;
			}
		}
	}while((c != '\r')||(c == EOF)||(n == 0));
	if (*(fp-1) == '\r')
		*(fp-1) = '\n';
	putchar('\n');
#ifndef MSDOS
#ifdef	SYSV_TERMIO
	if (ioctl (fileno(stdin), TCSETAW, &sgo) < 0){
		perror("Fgets: ioctl2");
		exit(0);
	}
#else
	if (ioctl(0, TIOCSETP, &sgo) < 0){
		perror("Fgets: ioctl2");
		exit(0);
	}
#endif
#endif
	if ((c == EOF)&&(fp == (char*)s))
		return NULL;
	else
		return s;
}
#endif		/* USE_FGETS */
