/*
 * @(#)kanji.c	1.34 Dec.14,1995
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * Copyright (C) yamasita@omronsoft.co.jp
 */

#if ! defined(CONFIGUR)
#ifdef WINDOWS
#	include <windows.h>
#	include	<mbctype.h>
#endif

#include	<stdio.h>

#ifdef MSDOS
#	include	<string.h>
#	if defined(WATTCP)
#		include <tcp.h>
#	endif
#	ifdef PCNFS
#		include "pcnfs.h"
#	endif
#endif /* MSDOS */

#include	"nntp.h"
#include	"gn.h"

#endif		/* ! CONFIGUR */

static void euctojis(),euctosjis();
static void sjistoeuc(),sjistojis();
static void jistoeuc(),jistosjis();

#if defined(WINDOWS) && ! defined(CONFIGUR)
static void	scroll_up();

static HDC		hdc;
static int	fast_mc_puts_flag = OFF;
#endif

/*
 * åɽ
 */
#if defined(WINDOWS) && ! defined(CONFIGUR)
int
mc_MessageBox(hwndParent,lpszText,lpszTitle,fuStyle)
HWND hwndParent;
LPCSTR lpszText,lpszTitle;
UINT fuStyle;
{
  extern void kanji_convert();
  
  char text[256],title[256];
  
  if ( lpszTitle == NULL ) {
    if ( gn.display_kanji_code == internal_kanji_code )
      strcpy(text,lpszText);
    else
      kanji_convert(internal_kanji_code,lpszText,
		    gn.display_kanji_code,text);
    return(MessageBox(hwndParent,text,NULL,fuStyle));
  }
  
  
  if ( gn.display_kanji_code == internal_kanji_code ){
    strcpy(text,lpszText);
    strcpy(title,lpszTitle);
  } else {
    kanji_convert(internal_kanji_code,lpszText,gn.display_kanji_code,text);
    kanji_convert(internal_kanji_code,lpszTitle,gn.display_kanji_code,title);
  }
  
  return(MessageBox(hwndParent,text,title,fuStyle));
}
#endif	/* WINDOWS */
void
mc_printf(format,arg1,arg2,arg3,arg4)
char *format,*arg1,*arg2,*arg3,*arg4;
{
  extern void mc_puts();
  char buf[NNTP_STRLEN*2+1];
  
  sprintf(buf,format,arg1,arg2,arg3,arg4);
  mc_puts(buf);
}

#if defined(WINDOWS) && ! defined(CONFIGUR)
void
fast_mc_puts_start()
{
  ScrollWindow(hWnd, 0, -wheight, NULL, NULL);
  memset(display_buf,' ',gn.lines*gn.columns);
  xpos = ypos = 0;
  
  HideCaret(hWnd);
  hdc = GetDC(hWnd);
  SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
  
  fast_mc_puts_flag = ON;
}
void
fast_mc_puts_end()
{
  ShowCaret(hWnd);
  ReleaseDC(hWnd, hdc);
  SetCaretPos(xpos * xsiz, ypos * ysiz);
  
  fast_mc_puts_flag = OFF;
}
void
mc_puts(sp)
char *sp;	/* internal_kanji_code Υå */
{
  extern void kanji_convert();
  
  static int	need_nl = OFF;
  char buf[NNTP_STRLEN*2+1];
  register char *bp;
  
  if ( gn.display_kanji_code == internal_kanji_code ) {
    bp = sp;
  } else {
    kanji_convert(internal_kanji_code,sp,gn.display_kanji_code,buf);
    bp = buf;
  }
  
  if ( fast_mc_puts_flag == OFF ) {
    HideCaret(hWnd);
    hdc = GetDC(hWnd);
    SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
  }
  
  while( *bp != 0 ) {
    if ( *bp == NL ) {
      need_nl = OFF;
      ypos++;
      xpos = 0;
      if (ypos >= gn.lines) {
	scroll_up();
	ypos--;
      }
      bp++;
      continue;
    }

    if ( *bp == BEL ) {
      MessageBeep(MB_OK);
      bp++;
      continue;
    }

    if ( *bp == TAB ) {
      need_nl = OFF;
      display_buf[xpos+ypos*gn.columns] = ' ';
      if ( fast_mc_puts_flag == OFF )
	TextOut(hdc, xpos * xsiz, ypos * ysiz, " ", 1);
      xpos++;
      while ( (xpos % 8) != 0 ) {
	display_buf[xpos+ypos*gn.columns] = ' ';
	if ( fast_mc_puts_flag == OFF )
	  TextOut(hdc, xpos * xsiz, ypos * ysiz, " ", 1);
	xpos++;
      }
      bp++;
      continue;
    }

    if ( need_nl != OFF ) {	/* ǽǡ뤬ߤޤäƤ */
      need_nl = OFF;
      ypos++;
      xpos = 0;
      if (ypos >= gn.lines) {
	scroll_up();
	ypos--;
      }
    }

    if ( _ismbblead(*bp) ) {	/* Х */
      if ( xpos >= gn.columns - 1 ) {
	need_nl = OFF;
	ypos++;
	xpos = 0;
	if (ypos >= gn.lines) {
	  scroll_up();
	  ypos--;
	}
      }
      display_buf[xpos+ypos*gn.columns] = *bp;
      display_buf[xpos+ypos*gn.columns+1] = bp[1];
      if ( fast_mc_puts_flag == OFF )
	TextOut(hdc, xpos * xsiz, ypos * ysiz, bp, 2);
      bp +=2;
      xpos += 2;
    } else {
      display_buf[xpos+ypos*gn.columns] = *bp;
      if ( fast_mc_puts_flag == OFF )
	TextOut(hdc, xpos * xsiz, ypos * ysiz, bp, 1);
      bp++;
      xpos++;
    }
    if ( xpos >= gn.columns ) {
      xpos = gn.columns -1;
      need_nl = ON;
    }
  }
  if ( fast_mc_puts_flag == OFF ) {
    ShowCaret(hWnd);
    ReleaseDC(hWnd, hdc);
    UpdateWindow(hWnd);
    SetCaretPos(xpos * xsiz, ypos * ysiz);
  }
}
static void
scroll_up()
{
  memcpy(&display_buf[0], &display_buf[gn.columns],(gn.lines-1)*gn.columns);
  memset(&display_buf[(gn.lines-1)*gn.columns],' ',gn.columns);
  if ( fast_mc_puts_flag == OFF )
    ScrollWindow(hWnd, 0, -ysiz, NULL, NULL);
}
#else	/* WINDOWS */
void
mc_puts(sp)
char *sp;	/* internal_kanji_code Υå */
{
  extern void kanji_convert();
  
  char dest[NNTP_STRLEN*2+1];
  
  if ( gn.display_kanji_code == internal_kanji_code ){
    printf("%s",sp);
  } else {
    kanji_convert(internal_kanji_code,sp,gn.display_kanji_code,dest);
    printf("%s",dest);
  }
}
#endif	/* WINDOWS */
/*
 * Ѵ
 */
void
kanji_convert(s_code,sp,d_code,dp)
int s_code;				/* ϴ */
register unsigned char *sp;		/* ʸ */
int d_code;				/* ϴ */
register unsigned char *dp;		/* ʸ */
{
  if ( s_code == d_code ) {
    strcpy(dp,sp);
  } else {
    switch (s_code) {
    case EUC:
      switch (d_code){
      case SJIS:
	euctosjis(sp,dp);
	break;
      default:			/* JIS */
	euctojis(sp,dp);
	break;
      }
      break;
    case SJIS:
      switch (d_code){
      case EUC:
	sjistoeuc(sp,dp);
	break;
      default:			/* JIS */
	sjistojis(sp,dp);
	break;
      }
      break;
    default:			/* JIS */
      switch (d_code){
      case SJIS:
	jistosjis(sp,dp);
	break;
      default:
	jistoeuc(sp,dp);
	break;
      }
      break;
    }
  }
}


/*
 * EUC -> JIS Ѵ
 */
static void
euctojis(sp,dp)
register unsigned char *sp;		/*  EUC ʸ */
register unsigned char *dp;		/*  JIS ʸ */
{
  int kanji_flag = 0;
  int kana_flag = 0;
  
  while( *sp != 0 ) {
    /* ASCII */
    if ( *sp <= DEL ){
      if ( kanji_flag == 1 || kana_flag == 1 ){
	*dp++ = ESC;
	*dp++ = '(';
	*dp++ = 'B';		/* *dp++ = 'J'; */
	kanji_flag = 0;
	kana_flag = 0;
      }
      *dp++ = *sp++;
      continue;
    }
    /* Ⱦѥ */
    if ( *sp == SS2 ) {
      if ( kana_flag == 0 ){
	*dp++ = ESC;
	*dp++ = '(';
	*dp++ = 'I';
	kana_flag = 1;
	kanji_flag = 0;
      }
      sp++;
      *dp++ = *sp++ & 0x7f;
      continue;
    }
    /*  */
    if ( kanji_flag == 0 ){
      *dp++ = ESC;
      *dp++ = '$';
      *dp++ = 'B';
      kanji_flag = 1;
      kana_flag = 0;
    }
    *dp++ = *sp++ & 0x7f;
    *dp++ = *sp++ & 0x7f;
  }
  if ( kanji_flag == 1  || kana_flag == 1 ){
    *dp++ = ESC;
    *dp++ = '(';
    *dp++ = 'B';		/* *dp++ = 'J'; */
  }
  *dp = 0;
}

/*
 * JIS -> EUC Ѵ
 */
static void
jistoeuc(sp,dp)
register unsigned char *sp;		/*  JIS ʸ */
register unsigned char *dp;		/*  EUC ʸ */
{
  int kanji_flag = 0;
  int kana_flag = 0;
  
  while( *sp != 0 ) {
    /* ץ󥹤Ƚ */
    if ( *sp == ESC ) {
      if ( sp[1] == '$' && ( sp[2] == '@' || sp[2] == 'B' ) ) {
	kanji_flag = 1;
	kana_flag = 0;
	sp += 3;
	continue;
      }
      if ( sp[1] == '(' && sp[2] == 'I' ) {
	kana_flag = 1;
	kanji_flag = 0;
	sp += 3;
	continue;
      }
      if ( sp[1] == '(' &&
	  (sp[2] == 'B' || sp[2] == 'H' || sp[2] == 'J' ) ) {
	kanji_flag = 0;
	kana_flag = 0;
	sp += 3;
	continue;
      }
    }
    /*  */
    if ( kanji_flag == 1 ) {
      *dp++ = *sp++ | 0x80;
      *dp++ = *sp++ | 0x80;
      continue;
    }
    /* Ⱦѥ */
    if ( kana_flag == 1 ) {
      *dp++ = SS2;
      *dp++ = *sp++ | 0x80;
      continue;
    }
    /* ASCII */
    *dp++ = *sp++;
  }
  *dp = 0;
}

/*
 * SJIS -> JIS Ѵ
 */
static void
sjistojis(sp,dp)
register unsigned char *sp;		/*  SJIS ʸ */
register unsigned char *dp;		/*  JIS ʸ */
{
  int kanji_flag = 0;
  int kana_flag = 0;
  register int jupper,jlower,supper,slower;
  
  while( *sp != 0 ) {
    /* ASCII */
    if ( *sp <= 0x7f ){
      if ( kanji_flag == 1 ){
	*dp++ = ESC;
	*dp++ = '(';
	*dp++ = 'B';		/* *dp++ = 'J'; */
	kanji_flag = 0;
	kana_flag = 0;
      }
      *dp++ = *sp++;
      continue;
    }
    /* Ⱦѥ */
    if ( 0xa0 <= *sp && *sp <= 0xdf ){
      if ( kana_flag == 0 ){
	*dp++ = ESC;
	*dp++ = '(';
	*dp++ = 'I';
	kana_flag = 1;
	kanji_flag = 0;
      }
      *dp++ = *sp++ & 0x7f;
      continue;
    }
    /*  */
    if ( kanji_flag == 0 ){
      *dp++ = ESC;
      *dp++ = '$';
      *dp++ = 'B';
      kanji_flag = 1;
      kana_flag = 0;
    }

    supper = *sp++;
    slower = *sp++;

    if(slower <= 0x9E){
      if( supper <= 0x9F )
	jupper = (supper-0x71) * 2 + 1;
      else
	jupper = (supper-0xB1) * 2 + 1;
      jlower = slower - 0x1F;
      if ( slower >= 0x80 )
	jlower--;
    } else {
      if( supper <= 0x9F )
	jupper = (supper-0x70) * 2;
      else
	jupper = (supper-0xB0) * 2;
      jlower = slower - 0x7E;
    }
    *dp++ = jupper;
    *dp++ = jlower;
  }
  if ( kanji_flag == 1 || kana_flag == 1 ){
    *dp++ = ESC;
    *dp++ = '(';
    *dp++ = 'B';		/* *dp++ = 'J'; */
  }
  *dp = 0;
}

/*
 * JIS -> SJIS Ѵ
 */
static void
jistosjis(sp,dp)
register unsigned char *sp;		/*  JIS ʸ */
register unsigned char *dp;		/*  SJIS ʸ */
{
  int kanji_flag = 0;
  int kana_flag = 0;
  register int jupper,jlower,supper,slower;
  
  while( *sp != 0 ) {
    /* ץ󥹤Ƚ */
    if ( *sp == ESC ) {
      if ( sp[1] == '$' && ( sp[2] == '@' || sp[2] == 'B' ) ) {
	kanji_flag = 1;
	kana_flag = 0;
	sp += 3;
	continue;
      }
      if ( sp[1] == '(' && sp[2] == 'I' ) {
	kana_flag = 1;
	kanji_flag = 0;
	sp += 3;
	continue;
      }
      if ( sp[1] == '(' &&
	  (sp[2] == 'B' || sp[2] == 'H' || sp[2] == 'J' ) ) {
	kanji_flag = 0;
	kana_flag = 0;
	sp += 3;
	continue;
      }
    }

    /*  */
    if ( kanji_flag == 1 ) {
      jupper = *sp++;
      jlower = *sp++;
      
      if( jupper <= 0x5E )
	supper = (jupper-1) / 2 + 0x71;
      else
	supper = (jupper-1) / 2 + 0xB1;
      
      if( jupper & 1 ){
	slower = jlower + 0x1F;
	if( slower >= 0x7F )
	  slower++;
      } else {
	slower = jlower + 0x7E;
      }
      *dp++ = supper;
      *dp++ = slower;
      continue;
    }
    
    /* Ⱦѥ */
    if ( kana_flag == 1 ) {
      *dp++ = *sp++ | 0x80;
      continue;
    }
    /* ASCII */
    *dp++ = *sp++;
  }
  *dp = 0;
}

/*
 * EUC -> SJIS Ѵ
 */
static void
euctosjis(sp,dp)
register unsigned char *sp;		/*  EUC ʸ */
register unsigned char *dp;		/*  SJIS ʸ */
{
  register int jupper,jlower,supper,slower;
  
  while( *sp != 0 ) {
    /* ASCII */
    if ( *sp <= 0x7f ){
      *dp++ = *sp++;
      continue;
    }
    /* Ⱦѥ */
    if ( *sp == SS2 ) {
      sp++;
      *dp++ = *sp++;
      continue;
    }
    /*  */
    jupper = *sp++ & 0x7f;
    jlower = *sp++ & 0x7f;

    if( jupper <= 0x5E )
      supper = (jupper-1) / 2 + 0x71;
    else
      supper = (jupper-1) / 2 + 0xB1;

    if( jupper & 1 ){
      slower = jlower + 0x1F;
      if( slower >= 0x7F )
	slower++;
    } else {
      slower = jlower + 0x7E;
    }
    *dp++ = supper;
    *dp++ = slower;
  }
  *dp = 0;
}

/*
 * SJIS -> EUC Ѵ
 */
static void
sjistoeuc(sp,dp)
register unsigned char *sp;		/*  SJIS ʸ */
register unsigned char *dp;		/*  euc ʸ */
{
  register int jupper,jlower,supper,slower;
  
  while( *sp != 0 ) {
    /* ASCII */
    if ( *sp <= 0x7f ){
      *dp++ = *sp++;
      continue;
    }
    /* Ⱦѥ */
    if ( 0xa0 <= *sp && *sp <= 0xdf ){
      *dp++ = SS2;
      *dp++ = *sp++;
      continue;
    }
    /*  */
    supper = *sp++;
    slower = *sp++;
    if(slower <= 0x9E){
      if( supper <= 0x9F )
	jupper = (supper-0x71) * 2 + 1;
      else
	jupper = (supper-0xB1) * 2 + 1;
      jlower = slower - 0x1F;
      if ( slower >= 0x80 )
	jlower--;
    } else {
      if( supper <= 0x9F )
	jupper = (supper-0x70) * 2;
      else
	jupper = (supper-0xB0) * 2;
      jlower = slower - 0x7E;
    }
    *dp++ = jupper | 0x80;
    *dp++ = jlower | 0x80;
  }
  *dp = 0;
}

/*
 * ESC Ƥղä
 */
void
add_esc(s_string,d_string)
register char *s_string;	/*  JIS ʸESC Ƥ뤫 */
register char *d_string;	/*  JIS ʸ */
{
  register char *sp;		/*  JIS ʸESC Ƥ뤫 */
  register char *dp;		/*  JIS ʸ */
  register char *pt;

  sp = s_string;
  dp = d_string;

  /* ⤷ĤǤ ESC СESC ǤϤʤ */
  for ( pt = sp ; *pt != 0 ; pt++ ) {
    if ( *pt == ESC ) {
      strcpy(dp,sp);
      return;
    }
  }

  /* ESC ɤĴ٤ */
  while ( *sp != 0 ) {

    if ( *sp != '$' || ( sp[1] != '@' && sp[1] != 'B' ) ) {
      /* ΥɥåȻǤϤʤ */
      *dp++ = *sp++;
      continue;
    }

    /* ΥɥåȻ꤫Τʤ */
    /* 򤺤äĴ٤ */
    for ( pt = &sp[1] ; *pt != 0 ; pt++ ) {
      if ( *pt != '$' && *pt != '(' )
	continue;

      if ( *pt == '$' ) {
	if ( pt[1] != '@' && pt[1] != 'B' ) 
	  continue;

	if ( pt[1] == sp[1] ) {	/* Ʊ󥹤뤳ȤϤʤ */
	  strcpy(d_string,s_string);
	  return;
	}
      }
      if ( *pt == '(' ) {
	if ( pt[1] != 'B' && pt[1] != 'H' && pt[1] != 'J' && pt[1] != 'I' )
	  continue;
      }
      /* ¿ʬ ESC  */
      *dp++ = ESC;
      while ( sp < pt )
	*dp++ = *sp++;
      *dp++ = ESC;
      *dp++ = *sp++;
      /* *dp++ = *sp++; break Ƥ for 롼פγ*/
      break;
    }
    *dp++ = *sp++;
  }
  *dp = 0;
}


/*
 * len ˼ޤ褦ʸڤ
 */
void
str_cut(buf,len)
unsigned char *buf;
int len;
{
  register unsigned char *pt;
  
  pt = buf;
  if ( internal_kanji_code == EUC ) {
    while (len > 0) {
      if ( *pt == 0 )
	return;
      if ( (*pt & 0x80) != 0 ) {
	if ( len == 1 ) {
	  *pt = 0;
	  return;
	}
	len--;
	pt++;
      }
      pt++;
      len--;
    }
  } else {
    while (len > 0) {
      if ( *pt == 0 )
	return;
      if ( (0x80 <= *pt && *pt <= 0x9f) || (0xe0 <= *pt && *pt <= 0xff) ){
	if ( len == 1 ) {
	  *pt = 0;
	  return;
	}
	len--;
	pt++;
      }
      pt++;
      len--;
    }
  }
  *pt = 0;
}
