/*
 * @(#)wingnsp.c	1.34 Jan.9,1996
 *
 * ޤ󡣤Ūʳλѡۤ¤ߤޤ
 * Copyright (C) yamasita@omronsoft.co.jp
 */

#include	<windows.h>
#include	<toolhelp.h>
#include	"wingnsp.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

#if defined (MSDOS)
#	if	defined ( OS2 )
#		define INCL_DOSFILEMGR
#		include <os2.h>
#	else
#		if defined (HUMAN68K)
#			include	<sys/dos.h>
#			include	<unistd.h>
#		else
#			include	<dos.h>
#		endif
#	endif
#	include	<stdlib.h>
#	include	<string.h>
#	if defined(WATTCP)
#		include <tcp.h>
#	endif
#	if !defined(HUMAN68K) && !defined(GNUDOS) && !defined(__TURBOC__)
#		include	<direct.h>
#	endif
#	ifdef __TURBOC__
#		include <dir.h>
#	endif
#	if defined (GNUDOS)
#		include	<dir.h>
#	endif
#	ifdef PCNFS
#		include "pcnfs.h"
#	endif
#	ifdef WINSOCK
#		include <winsock.h>
#	endif
#	ifdef QUICKWIN
#		include	<io.h>
#	endif
#	if defined (__TURBOC__)
extern unsigned _stklen = 10240;
#	endif
#endif /* MSDOS */

#include	"nntp.h"
#include	"gn.h"

#define	READED	1
#define	EXISTS	2

extern void mc_puts(),mc_printf();
extern int post_file();
extern int mail_file();
extern void smtp_close_server();
extern int get_1_header_file();
extern void memory_error();

extern int gn_init();
extern int get_newsrc();
extern void open_server();
extern int get_active();
extern int get_newsgroups();
extern void check_group();
extern void close_server();
extern void kanji_convert();
#ifdef	MSDOS
extern int SetDisk();
#endif

static int check_post();
static int check_reply();
static int post();
static int reply();
extern int expire();
extern int expire_1ng();
extern int make_newsgroups();
extern int make_history();
extern int make_history_1ng();
extern int get_article();
extern int get_article_1ng();
extern int make_active();
static int post_article();
static int send_mail();
extern char *find_first_file(),*find_next_file();

extern int mc_MessageBox();
extern void set_hourglass(),reset_cursor();
static HTASK exeTask;
static LPFNNOTIFYCALLBACK NprocInst;

extern int newsrc_flag;		/* newsrc ɤ߹飰ʤäݣ */

extern int interactive_send;	/* interactive */
extern char *tmp_file_f;

int PASCAL
WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;
HANDLE hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{
  extern BOOL InitApplication(),InitInstance();
  extern void	create_arg();
  
  MSG msg;
  
  if (!hPrevInstance) {
    if (!InitApplication(hInstance))
      return(FALSE);
  }
  
  if (!InitInstance(hInstance, nCmdShow))
    return(FALSE);
  
  /* argc/argv κ */
  create_arg(lpCmdLine);
  
  while (GetMessage(&msg, NULL, NULL, NULL) ){
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  
#if ! defined(NO_NET)
  if ( DO_POST || DO_GET ) {
    /* ФȤ³ڤ */
    close_server();
  }
#if defined(WINSOCK)
  if ( DO_POST || DO_MAIL || DO_GET )
    WSACleanup();
#endif
#endif	/* NO_NET */
  return(msg.wParam);
}


long CALLBACK __export
MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;
UINT message;
WPARAM wParam;
LPARAM lParam;
{
  BOOL __export CALLBACK About();
  extern void auth_set_passwd();
  BOOL __export CALLBACK get_passwd();
  BOOL __export CALLBACK Done();
  extern int auth_check_pass();
  
  newsgroup_t *ng;
  register int y;
  HDC hdc;
  TEXTMETRIC tm;
  PAINTSTRUCT	ps;
  
  switch (message) {
  case WM_CREATE:
    hdc = GetDC(hWnd);
    SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
    GetTextMetrics(hdc, &tm);
    xsiz = tm.tmAveCharWidth;
    ysiz = tm.tmHeight;
    ReleaseDC(hWnd, hdc);
    return(NULL);
    
  case WM_COMMAND:			/* ˥塼 */
    switch (wParam) {
    case IDM_ABOUT:
      DialogBox(hInst,
		"ABOUTBOX",
		hWnd,
		About);
      return(NULL);
    }
    return(DefWindowProc(hWnd, message, wParam, lParam));
    
  case WM_SETFOCUS:
    CreateCaret(hWnd, NULL, xsiz, ysiz);
    SetCaretPos(xpos * xsiz, ypos * ysiz);
    ShowCaret(hWnd);
    return(NULL);
    
  case WM_KILLFOCUS:
    HideCaret(hWnd);
    DestroyCaret();
    return(NULL);
    
  case WM_DESTROY:             /* ɥ˴  */
    PostQuitMessage(0);
    break;
    
  case WM_SIZE:
    if ( wParam == SIZE_MINIMIZED )
      return(NULL);
    wwidth = LOWORD(lParam);
    wheight = HIWORD(lParam);
    if (gn.columns == max(1,wwidth / xsiz) && gn.lines == max(1,wheight / ysiz))
      return(NULL);
    gn.columns = max(1, wwidth / xsiz);
    gn.lines = max(1, wheight / ysiz);
    if ( display_buf != 0 )
      free(display_buf);
    if ( (display_buf = malloc(gn.lines*gn.columns)) == NULL ) {
      memory_error();
      return(NULL);
    }
    memset(display_buf,' ',gn.lines*gn.columns);
    xpos = ypos = 0;
    return(NULL);
    
  case WM_PAINT:
    if ( display_buf == 0 )
      return(NULL);
    hdc = BeginPaint(hWnd, &ps);
    SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
    for (y = 0; y < gn.lines; y++)
      TextOut(hdc, 0, y * ysiz, &display_buf[y*gn.columns], gn.columns);
    EndPaint(hWnd, &ps);
    return(NULL);
    
    
    
  case WM_START:
    if ( gn_init((int)wParam,(char **)lParam) == QUIT ) {
      PostQuitMessage(0);
      return(NULL);
    }
    if ( gn.newsspool[1] == ':' ) {
      if (SetDisk(toupper(gn.newsspool[0])-'A')){
	mc_MessageBox(hWnd,"NEWSSPOOL ˻ꤵ줿ɥ饤֤ϻѤǤޤ ",gn.newsspool,MB_OK);
	PostQuitMessage(0);
	return(NULL);
      }
    }

#if defined(NO_NET)
    PostMessage(hWnd,WM_GETACTIVE,0,0L);
#else
    if ( DO_POST || DO_MAIL)
      PostMessage(hWnd,WM_GETPASS,0,0L);
    else
      PostMessage(hWnd,WM_OPENSERVER,0,0L);
#endif
    return(NULL);

#if ! defined(NO_NET)
  case WM_GETPASS:
    if (gn.passwd != 0 ) {
      auth_set_passwd();
      SendMessage(hWnd, WM_CHECKPASS,0 , 0L);
      return(NULL);
    }

    DialogBox(hInst,
	      "IDD_GETPASSWD",
	      hWnd,
	      get_passwd);
    return(NULL);

  case WM_CHECKPASS:		/* ѥɾȹ */
    if ( auth_check_pass() != CONT ) {
      PostQuitMessage(0);
      return(NULL);
    }
    PostMessage(hWnd,WM_OPENSERVER,0,0L);
    return(NULL);

  case WM_OPENSERVER:		/* ˥塼ФȤ³  */
    if ( DO_POST || DO_GET ) {
      mc_printf("%s ³Ƥޤ\n",gn.nntpserver);
      open_server();
    }
    PostMessage(hWnd,WM_POST,0,0L);
    return(NULL);

  case WM_POST:		/*  */
    if ( DO_POST ) {
      switch (check_post()) {
      case ERROR:
	return(NULL);
      case NEXT:
	PostMessage(hWnd,WM_POST_1,0,0L);
	return(NULL);
      case CONT:
	PostMessage(hWnd,WM_REPLY,0,0L);
	return(NULL);
      }
    }
    PostMessage(hWnd,WM_REPLY,0,0L);
    return(NULL);

  case WM_POST_1:
    switch ( post() ) {
    case ERROR:
      return(NULL);
    case NEXT:
      PostMessage(hWnd,WM_POST_1,0,0L);
      return(NULL);
    case CONT:
      return(NULL);
    case QUIT:
      PostMessage(hWnd,WM_REPLY,0,0L);
      return(NULL);
    }
    return(NULL);
    
  case WM_POSTCONF:
    PostMessage(hWnd,WM_POST_1,0,0L);
    return(NULL);
		
  case WM_REPLY:		/* ץ饤ᥤ */
    if ( DO_MAIL ) {
      switch ( check_reply() ) {
      case ERROR:
	return(NULL);
      case NEXT:
	PostMessage(hWnd,WM_REPLY_1,0,0L);
	return(NULL);
      case CONT:
	PostMessage(hWnd,WM_GETACTIVE,0,0L);
	return(NULL);
      }
    }
    PostMessage(hWnd,WM_GETACTIVE,0,0L);
    return(NULL);
    
  case WM_REPLY_1:
    switch ( reply() ) {
    case ERROR:
      return(NULL);
    case NEXT:
      PostMessage(hWnd,WM_REPLY_1,0,0L);
      return(NULL);
    case CONT:
      return(NULL);
    case QUIT:
      PostMessage(hWnd,WM_GETACTIVE,0,0L);
      return(NULL);
    }
    return(NULL);
    
  case WM_MAILCONF:
    PostMessage(hWnd,WM_REPLY_1,0,0L);
    return(NULL);

#endif	/* NO_NET */

  case WM_GETACTIVE:	/* ƥ֥եμ */
    if ( DO_EXPIRE || DO_GET ) {
      switch ( get_active()) {
      case CONNECTION_CLOSED:
	mc_MessageBox(hWnd,"˥塼ФȤ³ڤޤ","",MB_OK);
	PostQuitMessage(0);
	return(NULL);
      case ERROR:
	return(NULL);
      }
    }
    PostMessage(hWnd,WM_READNEWSRC,0,0L);
    return(NULL);
   
  case WM_READNEWSRC:	/* .newsrc եɤ߹ */
    if ( DO_EXPIRE || DO_GET ) {
      if ( (newsrc_flag = get_newsrc()) == ERROR )
	return(NULL);
    }
    PostMessage(hWnd,WM_CHECKGROUP,0,0L);
    return(NULL);

  case WM_CHECKGROUP:	/* ˥塼롼פΥå */
    if ( DO_EXPIRE || DO_GET )
      check_group(0);
    PostMessage(hWnd,WM_GETNEWSGROUPS,0,0L);
    return(NULL);

  case WM_GETNEWSGROUPS:			/* ƥ롼פμ */
    if ( gn.description == 1 && DO_GET ) {
      switch ( get_newsgroups() ){
      case CONNECTION_CLOSED:
	mc_MessageBox(hWnd,"˥塼ФȤ³ڤޤ","",MB_OK);
	PostQuitMessage(0);
	return(NULL);
      case ERROR:
	return(NULL);
      }
    }
    PostMessage(hWnd,WM_EXPIRE,0,0L);
    return(NULL);
    
  case WM_EXPIRE:	/* ɤεξõ */
    if ( DO_EXPIRE == 0) {
#if ! defined(NO_NET)
      PostMessage(hWnd,WM_MKNEWSGROUPS,0,0L);
#else
      PostMessage(hWnd,WM_MKACTIVE,0,0L);
#endif	/* NO_NET */
      return(NULL);
    }
    set_hourglass();
    if ( expire() != CONT ) {
      reset_cursor();
      return(NULL);
    }
    ng = newsrc;
    PostMessage(hWnd,WM_EXPIRE_1,0,(long)ng);
    return(NULL);

  case WM_EXPIRE_1:
    ng = (newsgroup_t *)lParam;
    expire_1ng(ng);
    ng = ng->next;
    if ( ng != 0 ) {
      PostMessage(hWnd,WM_EXPIRE_1,0,(long)ng);
    }else {
      reset_cursor();
#if ! defined(NO_NET)
      PostMessage(hWnd,WM_MKNEWSGROUPS,0,0L);
#else
      PostMessage(hWnd,WM_MKACTIVE,0,0L);
#endif	/* NO_NET */
    }
    return(NULL);



#if ! defined(NO_NET)
  case WM_MKNEWSGROUPS:		/* newsgroups κ */
    if ( gn.description == 1 && DO_GET ) {
      if ( make_newsgroups() != CONT )
	return(NULL);
    }
    PostMessage(hWnd,WM_GETARTICLE,0,0L);
    return(NULL);

  case WM_GETARTICLE:		/* μ */
    if ( DO_GET ) {
      if ( get_article() != CONT )
	return(NULL);
      ng = newsrc;
      PostMessage(hWnd,WM_GETARTICLE_1,0,(long)ng);
      return(NULL);
    }
    PostMessage(hWnd,WM_MKACTIVE,0,0L);
    return(NULL);

  case WM_GETARTICLE_1:
    ng = (newsgroup_t *)lParam;
    if ( get_article_1ng(ng) != CONT )
      return(NULL);
    ng = ng->next;
    if ( ng != 0 )
      PostMessage(hWnd,WM_GETARTICLE_1,0,(long)ng);
    else
      PostMessage(hWnd,WM_MKACTIVE,0,0L);
    return(NULL);

#endif	/* NO_NET */

  case WM_MKACTIVE:	/* active κ */
    if ( DO_GET ) {
      if ( make_active() != CONT )
	return(NULL);
    }
    PostMessage(hWnd,WM_MKHISTORY,0,0L);
    return(NULL);

  case WM_MKHISTORY:		/* history κ */
    if ( gn.use_history && DO_GET ) {
      set_hourglass();
      if ( make_history() != CONT ) {
	reset_cursor();
	mc_puts("\nhistory κ˼Ԥޤ\n");
	return(NULL);
      }
      ng = newsrc;
      PostMessage(hWnd,WM_MKHISTORY_1,0,(long)ng);
      return(NULL);
    }
    PostMessage(hWnd,WM_DONE,0,0L);
    return(NULL);

  case WM_MKHISTORY_1:		/* history κ */
    ng = (newsgroup_t *)lParam;
    make_history_1ng(ng);
    ng = ng->next;
    if ( ng != 0 ) {
      PostMessage(hWnd,WM_MKHISTORY_1,0,(long)ng);
    } else {
      reset_cursor();
      PostMessage(hWnd,WM_DONE,0,0L);
    }
    return(NULL);
    
  case WM_DONE:		/* λ */
    MessageBox(hWnd,"Done","gnspool",MB_OK);
    PostQuitMessage(0);
    return(NULL);
    
  case WM_CONNECTIONCLOSED:	/* ³ڤ줿 */
    mc_MessageBox(hWnd,"˥塼ФȤ³ڤޤ","",MB_OK);
    PostQuitMessage(0);
    return(NULL);
    
  default:
    return(DefWindowProc(hWnd, message, wParam, lParam));
  }
  return(NULL);
}

static int
check_post()
{
  char dir[PATH_LEN];
  struct stat stat_buf;
  
  strcpy(dir,gn.newsspool);
  if ( dir[strlen(dir)-1] != SLASH_CHAR)
    strcat(dir,SLASH_STR);
  strcat(dir,"news.out");
  
  if ( stat(dir,&stat_buf) != 0 )
    return(CONT);	/* ݥȵʤ */
  
  if ( chdir(dir) != 0 ) {
    mc_MessageBox(hWnd,"cd Ǥޤ ", dir,MB_OK);
    return(ERROR);
  }
  
  mc_puts("\nݥȤޤ\n");
  return(NEXT);
}
static int
post()
{
  if ( (tmp_file_f = find_first_file()) != (char *)0 ) {
    if ( tmp_file_f[0] == 'g' || tmp_file_f[0] == 'G' ) {
      return(post_article(tmp_file_f));
    }

    while ( (tmp_file_f = find_next_file()) != (char *)0 ) {
      if ( tmp_file_f[0] == 'g' || tmp_file_f[0] == 'G' ) {
	return(post_article(tmp_file_f));
      }
    }
  }
  
  if ( chdir(gn.newsspool) != 0 ) {
    mc_MessageBox(hWnd,"cd Ǥޤ ", gn.newsspool,MB_OK);
    return(CONT);
  }
  
  if ( rmdir("news.out") != 0 )
    mc_MessageBox(hWnd,"rmdir Ǥޤ ", "news.out", MB_OK);

  return(QUIT);
}
static char post_newsgroups[NNTP_STRLEN*2+1];
static char post_subject[NNTP_STRLEN*2+1];

static int
post_article()
{
  BOOL __export CALLBACK post_1file();
  BOOL __export CALLBACK _loadds NotifyHandler_post();
  
  FILE *fp;
  char buf[NNTP_STRLEN*2+1];
  char resp[NNTP_STRLEN*2+1];
  char edit[128];
  WORD	wreturn;
  
  /* إåɽ */
  if ( ( fp = fopen(tmp_file_f,"r") ) == NULL ){
    mc_MessageBox(hWnd,"եΥץ˼Ԥޤ",
		  tmp_file_f,MB_OK);
    return(ERROR);
  }
  
  get_1_header_file(buf,resp,fp);
  
  while (1) {
    if (resp[0] == 0 )
      break;
    get_1_header_file(buf,resp,fp);
    if (buf[0] == 0 )
      break;

    if ( strncmp(buf,"Subject: ",9) == 0)
      strcpy(post_subject,buf);

    if ( strncmp(buf,"Newsgroups: ",12) == 0)
      strcpy(post_newsgroups,buf);
  }
  
  fclose(fp);
  
  ShowWindow(hWnd,SW_RESTORE);

  if (interactive_send == OFF) {
    mc_printf("%s\n",post_subject);
    mc_printf("%s\n\n",post_newsgroups);
    if ( post_file(tmp_file_f) != CONT )
      return(ERROR);
    if ( unlink(tmp_file_f) != 0 ) {
      mc_MessageBox(hWnd,"Ǥޤ ",tmp_file_f,MB_OK);
      return(ERROR);
    }
    return(NEXT);
  }

  switch (DialogBox(hInst,	/* ߤΥ󥹥 */
		    "IDD_GNSPOOLSEND", /* Ѥ꥽ */
		    hWnd,	/* ƥɥΥϥɥ */
		    post_1file)) {
  case 'y':
    if ( post_file(tmp_file_f) != CONT )
      return(ERROR);
    if ( unlink(tmp_file_f) != 0 ) {
      mc_MessageBox(hWnd,"Ǥޤ ",tmp_file_f,MB_OK);
      return(ERROR);
    }
    return(NEXT);
    
  case 'e':
    sprintf(edit,"%s %s.",gn.editor,tmp_file_f);
    wreturn = WinExec(edit,SW_SHOW);
    if ( wreturn < 32 ){
      sprintf(edit,"ǥεư˼Ԥޤ %d",wreturn);
      mc_MessageBox(hWnd,edit,"",MB_ICONSTOP);
    } else {
      exeTask = GetWindowTask(GetActiveWindow());
      NprocInst = (LPFNNOTIFYCALLBACK)
	MakeProcInstance(NotifyHandler_post, hInst);
      NotifyRegister(NULL, NprocInst, NF_NORMAL);
      
      ShowWindow(hWnd,SW_MINIMIZE);
    }
    break;
    
  case 'n':
    if ( unlink(tmp_file_f) != 0 ) {
      mc_MessageBox(hWnd,"Ǥޤ ",tmp_file_f,MB_OK);
      return(ERROR);
    }
    return(NEXT);
    
  default:
    return(ERROR);
  }
  return(CONT);
}
BOOL __export CALLBACK
post_1file(hDlg, message, wParam, lParam)
HWND hDlg;                       /* ܥåɥΥϥɥ */
unsigned message;                /* åΥ                     */
WORD wParam;                     /* åͭξ                   */
LONG lParam;
{
  char sendtext[128];
  
  switch (message) {
  case WM_INITDIALOG:
    SetDlgItemText(hDlg, IDC_NEWSGROUPS, (LPSTR)post_newsgroups);
    SetDlgItemText(hDlg, IDC_SUBJECT, (LPSTR)post_subject);
    kanji_convert(internal_kanji_code,"˥ݥȤޤ",
		  gn.display_kanji_code,sendtext);
    SetDlgItemText(hDlg, IDC_TEXT, (LPSTR)sendtext);
    kanji_convert(internal_kanji_code,"(\036Y)",
		  gn.display_kanji_code, sendtext);
    SetDlgItemText(hDlg, IDOK, sendtext);
    kanji_convert(internal_kanji_code,"ʤ(\036N)",
		  gn.display_kanji_code, sendtext);
    SetDlgItemText(hDlg, IDCANCEL, sendtext);
    kanji_convert(internal_kanji_code,"⤦Խ(\036E)",
		  gn.display_kanji_code, sendtext);
    SetDlgItemText(hDlg, IDRETRY, sendtext);
    return(TRUE);

  case WM_COMMAND:
    switch (wParam) {
    case IDOK:
      EndDialog(hDlg, 'y');
      return(TRUE);

    case IDCANCEL:
      EndDialog(hDlg, 'n');
      return(TRUE);

    case IDRETRY:
      EndDialog(hDlg, 'e');
      return(TRUE);
    }
    break;
  }
  return(FALSE);
}
BOOL __export CALLBACK _loadds
NotifyHandler_post(WORD wID, DWORD dwData)
{
  if (wID == NFY_EXITTASK ) {
    if(GetCurrentTask() == exeTask){
      PostMessage(hWnd, WM_POSTCONF,0 , 0L);
      return(TRUE);
    }
  }
  return(FALSE);
}

static int
check_reply()
{
  char dir[PATH_LEN];
  struct stat stat_buf;
  
  strcpy(dir,gn.newsspool);
  if ( dir[strlen(dir)-1] != SLASH_CHAR)
    strcat(dir,SLASH_STR);
  strcat(dir,"mail.out");
  
  if ( stat(dir,&stat_buf) != 0 )
    return(CONT);		/* ץ饤ᥤʤ */
  
  if ( chdir(dir) != 0 ) {
    mc_MessageBox(hWnd,"cd Ǥޤ ", dir,MB_OK);
    return(ERROR);
  }
  
  mc_puts("\nץ饤ᥤޤ\n");
  return(NEXT);
}
static int
reply()
{
  if ( (tmp_file_f = find_first_file()) != (char *)0 ) {
    if ( tmp_file_f[0] == 'g' || tmp_file_f[0] == 'G' ) {
      return(send_mail(tmp_file_f));
    }

    while ( (tmp_file_f = find_next_file()) != (char *)0 ) {
      if ( tmp_file_f[0] == 'g' || tmp_file_f[0] == 'G' ) {
	return(send_mail(tmp_file_f));
      }
    }
  }
  
  if ( init_smtp_server != 0 )
    smtp_close_server();

  if ( chdir(gn.newsspool) != 0 ) {
    mc_MessageBox(hWnd,"cd Ǥޤ ", gn.newsspool,MB_OK);
    return(CONT);
  }
  
  if ( rmdir("mail.out") != 0 )
    mc_MessageBox(hWnd,"rmdir Ǥޤ ", "mail.out", MB_OK);

  return(QUIT);
}
static char mail_to[NNTP_STRLEN*2+1];
static char mail_subject[NNTP_STRLEN*2+1];

static int
send_mail()
{
  BOOL __export CALLBACK mail_1file();
  BOOL __export CALLBACK _loadds NotifyHandler_mail();
  
  FILE *fp;
  char buf[NNTP_STRLEN*2+1];
  char resp[NNTP_STRLEN*2+1];
  char edit[128];
  WORD	wreturn;
  
  /* إåɽ */
  if ( ( fp = fopen(tmp_file_f,"r") ) == NULL ){
    mc_MessageBox(hWnd,"եΥץ˼Ԥޤ",
		  tmp_file_f,MB_OK);
    return(ERROR);
  }
  
  get_1_header_file(buf,resp,fp);
  
  while (1) {
    if (resp[0] == 0 )
      break;
    get_1_header_file(buf,resp,fp);
    if (buf[0] == 0 )
      break;

    if ( strncmp(buf,"To: ",4) == 0)
      strcpy(mail_to,buf);
    if ( strncmp(buf,"Subject: ",9) == 0)
      strcpy(mail_subject,buf);
  }
  
  fclose(fp);

  ShowWindow(hWnd,SW_RESTORE);

  if (interactive_send == OFF) {
    mc_printf("%s\n",mail_to);
    mc_printf("%s\n\n",mail_subject);
    if ( mail_file(tmp_file_f) != CONT )
      return(ERROR);
    if ( unlink(tmp_file_f) != 0 ) {
      mc_MessageBox(hWnd,"Ǥޤ ",tmp_file_f,MB_OK);
      return(ERROR);
    }
    return(NEXT);
  }

  switch (DialogBox(hInst,	/* ߤΥ󥹥 */
		    "IDD_GNSPOOLSEND", /* Ѥ꥽ */
		    hWnd,	/* ƥɥΥϥɥ */
		    mail_1file)) {
  case 'y':
    if ( mail_file(tmp_file_f) != CONT )
      return(ERROR);
    if ( unlink(tmp_file_f) != 0 ) {
      mc_MessageBox(hWnd,"Ǥޤ ",tmp_file_f,MB_OK);
      return(ERROR);
    }
    return(NEXT);
    
  case 'e':
    sprintf(edit,"%s %s.",gn.editor,tmp_file_f);
    wreturn = WinExec(edit,SW_SHOW);
    if ( wreturn < 32 ){
      sprintf(edit,"ǥεư˼Ԥޤ %d",wreturn);
      mc_MessageBox(hWnd,edit,"",MB_ICONSTOP);
    } else {
      exeTask = GetWindowTask(GetActiveWindow());
      NprocInst = (LPFNNOTIFYCALLBACK)
	MakeProcInstance(NotifyHandler_mail, hInst);
      NotifyRegister(NULL, NprocInst, NF_NORMAL);
      
      ShowWindow(hWnd,SW_MINIMIZE);
    }
    break;
    
  case 'n':
    if ( unlink(tmp_file_f) != 0 ) {
      mc_MessageBox(hWnd,"Ǥޤ ",tmp_file_f,MB_OK);
      return(ERROR);
    }
    return(NEXT);
    
  default:
    return(ERROR);
  }
  return(CONT);
}
BOOL __export CALLBACK
mail_1file(hDlg, message, wParam, lParam)
HWND hDlg;                       /* ܥåɥΥϥɥ */
unsigned message;                /* åΥ                     */
WORD wParam;                     /* åͭξ                   */
LONG lParam;
{
  char sendtext[128];
  
  switch (message) {
  case WM_INITDIALOG:
    SetDlgItemText(hDlg, IDC_NEWSGROUPS, (LPSTR)mail_to);
    SetDlgItemText(hDlg, IDC_SUBJECT, (LPSTR)mail_subject);
    kanji_convert(internal_kanji_code,"˥ᥤ뤷ޤ",
		  gn.display_kanji_code,sendtext);
    SetDlgItemText(hDlg, IDC_TEXT, (LPSTR)sendtext);
    kanji_convert(internal_kanji_code,"(\036Y)",
		  gn.display_kanji_code, sendtext);
    SetDlgItemText(hDlg, IDOK, sendtext);
    kanji_convert(internal_kanji_code,"ʤ(\036N)",
		  gn.display_kanji_code, sendtext);
    SetDlgItemText(hDlg, IDCANCEL, sendtext);
    kanji_convert(internal_kanji_code,"⤦Խ(\036E)",
		  gn.display_kanji_code, sendtext);
    SetDlgItemText(hDlg, IDRETRY, sendtext);
    return(TRUE);

  case WM_COMMAND:
    switch (wParam) {
    case IDOK:
      EndDialog(hDlg, 'y');
      return(TRUE);

    case IDCANCEL:
      EndDialog(hDlg, 'n');
      return(TRUE);

    case IDRETRY:
      EndDialog(hDlg, 'e');
      return(TRUE);
    }
    break;
  }
  return(FALSE);
}
BOOL __export CALLBACK _loadds
NotifyHandler_mail(WORD wID, DWORD dwData)
{
  if (wID == NFY_EXITTASK ) {
    if(GetCurrentTask() == exeTask){
      PostMessage(hWnd, WM_MAILCONF,0 , 0L);
      return(TRUE);
    }
  }
  return(FALSE);
}
